xref: /titanic_41/usr/src/tools/scripts/nightly.sh (revision 95efa359b507db290a2484b8f615822b1e06096f)
1#!/bin/ksh -p
2#
3# CDDL HEADER START
4#
5# The contents of this file are subject to the terms of the
6# Common Development and Distribution License (the "License").
7# You may not use this file except in compliance with the License.
8#
9# You can obtain a copy of the license at usr/src/OPENSOLARIS.LICENSE
10# or http://www.opensolaris.org/os/licensing.
11# See the License for the specific language governing permissions
12# and limitations under the License.
13#
14# When distributing Covered Code, include this CDDL HEADER in each
15# file and include the License file at usr/src/OPENSOLARIS.LICENSE.
16# If applicable, add the following below this CDDL HEADER, with the
17# fields enclosed by brackets "[]" replaced with your own identifying
18# information: Portions Copyright [yyyy] [name of copyright owner]
19#
20# CDDL HEADER END
21#
22
23#
24# Copyright 2008 Sun Microsystems, Inc.  All rights reserved.
25# Use is subject to license terms.
26#
27# Based on the nightly script from the integration folks,
28# Mostly modified and owned by mike_s.
29# Changes also by kjc, dmk.
30#
31# BRINGOVER_WS may be specified in the env file.
32# The default is the old behavior of CLONE_WS
33#
34# -i on the command line, means fast options, so when it's on the
35# command line (only), lint and check builds are skipped no matter what
36# the setting of their individual flags are in NIGHTLY_OPTIONS.
37#
38# LINTDIRS can be set in the env file, format is a list of:
39#
40#	/dirname-to-run-lint-on flag
41#
42#	Where flag is:	y - enable lint noise diff output
43#			n - disable lint noise diff output
44#
45#	For example: LINTDIRS="$SRC/uts n $SRC/stand y $SRC/psm y"
46#
47# -A flag in NIGHTLY_OPTIONS checks ABI diffs in .so files
48# This option requires a couple of scripts.
49#
50# OPTHOME and TEAMWARE may be set in the environment to override /opt
51# and /opt/teamware defaults.
52#
53
54#
55# The CDPATH variable causes ksh's `cd' builtin to emit messages to stdout
56# under certain circumstances, which can really screw things up; unset it.
57#
58unset CDPATH
59
60# Get the absolute path of the nightly script that the user invoked.  This
61# may be a relative path, and we need to do this before changing directory.
62nightly_path=`whence $0`
63nightly_ls="`ls -l $nightly_path`"
64
65#
66# Keep track of where we found nightly so we can invoke the matching
67# which_scm script.  If that doesn't work, don't go guessing, just rely
68# on the $PATH settings, which will generally give us either /opt/onbld
69# or the user's workspace.
70#
71WHICH_SCM=$(dirname $nightly_path)/which_scm
72if [[ ! -x $WHICH_SCM ]]; then
73	WHICH_SCM=which_scm
74fi
75
76#
77# Print the tag string used to identify a build (e.g., "DEBUG
78# open-only")
79# usage: tagstring debug-part open-part
80#
81tagstring() {
82	debug_part=$1
83	open_part=$2
84
85	if [ -n "$open_part" ]; then
86		echo "$debug_part $open_part"
87	else
88		echo "$debug_part"
89	fi
90}
91
92#
93# Function to do a DEBUG and non-DEBUG build. Needed because we might
94# need to do another for the source build, and since we only deliver DEBUG or
95# non-DEBUG packages.
96#
97# usage: normal_build [-O]
98# -O	OpenSolaris delivery build.  Put the proto area and
99#	(eventually) packages in -open directories.  Use skeleton
100#	closed binaries.  Don't generate archives--that needs to be
101#	done later, after we've generated the closed binaries.  Also
102#	skip the package build (until 6414822 is fixed).
103#
104
105normal_build() {
106
107	typeset orig_p_FLAG="$p_FLAG"
108	typeset orig_a_FLAG="$a_FLAG"
109
110	suffix=""
111	open_only=""
112	while getopts O FLAG $*; do
113		case $FLAG in
114		O)
115			suffix="-open"
116			open_only="open-only"
117			p_FLAG=n
118			a_FLAG=n
119			;;
120		esac
121	done
122
123	# non-DEBUG build begins
124
125	if [ "$F_FLAG" = "n" ]; then
126		set_non_debug_build_flags
127		mytag=`tagstring "non-DEBUG" "$open_only"`
128		build "$mytag" "$suffix-nd" "$MULTI_PROTO"
129		if [ "$build_ok" = "y" -a "$X_FLAG" = "y" -a \
130		    "$p_FLAG" = "y" ]; then
131			copy_ihv_pkgs non-DEBUG -nd
132		fi
133	else
134		echo "\n==== No non-DEBUG $open_only build ====\n" >> "$LOGFILE"
135	fi
136
137	# non-DEBUG build ends
138
139	# DEBUG build begins
140
141	if [ "$D_FLAG" = "y" ]; then
142		set_debug_build_flags
143		mytag=`tagstring "DEBUG" "$open_only"`
144		build "$mytag" "$suffix" "$MULTI_PROTO"
145		if [ "$build_ok" = "y" -a "$X_FLAG" = "y" -a \
146		    "$p_FLAG" = "y" ]; then
147			copy_ihv_pkgs DEBUG ""
148		fi
149
150	else
151		echo "\n==== No DEBUG $open_only build ====\n" >> "$LOGFILE"
152	fi
153
154	# DEBUG build ends
155
156	p_FLAG="$orig_p_FLAG"
157	a_FLAG="$orig_a_FLAG"
158}
159
160#
161# usage: run_hook HOOKNAME ARGS...
162#
163# If variable "$HOOKNAME" is defined, insert a section header into
164# our logs and then run the command with ARGS
165#
166run_hook() {
167	HOOKNAME=$1
168    	eval HOOKCMD=\$$HOOKNAME
169	shift
170
171	if [ -n "$HOOKCMD" ]; then
172	    	(
173			echo "\n==== Running $HOOKNAME command: $HOOKCMD ====\n"
174		    	( $HOOKCMD "$@" 2>&1 )
175			if [ "$?" -ne 0 ]; then
176			    	# Let exit status propagate up
177			    	touch $TMPDIR/abort
178			fi
179		) | tee -a $mail_msg_file >> $LOGFILE
180
181		if [ -f $TMPDIR/abort ]; then
182			build_ok=n
183			echo "\nAborting at request of $HOOKNAME" |
184				tee -a $mail_msg_file >> $LOGFILE
185			exit 1
186		fi
187	fi
188}
189
190#
191# usage: filelist DESTDIR PATTERN
192#
193filelist() {
194	DEST=$1
195	PATTERN=$2
196	cd ${DEST}
197
198	OBJFILES=${ORIG_SRC}/xmod/obj_files
199	if [ ! -f ${OBJFILES} ]; then
200		return;
201	fi
202	for i in `grep -v '^#' ${OBJFILES} | \
203	    grep ${PATTERN} | cut -d: -f2 | tr -d ' \t'`
204	do
205		# wildcard expansion
206		for j in $i
207		do
208			if [ -f "$j" ]; then
209				echo $j
210			fi
211			if [ -d "$j" ]; then
212				echo $j
213			fi
214		done
215	done | sort | uniq
216}
217
218# function to save off binaries after a full build for later
219# restoration
220save_binaries() {
221	# save off list of binaries
222	echo "\n==== Saving binaries from build at `date` ====\n" | \
223	    tee -a $mail_msg_file >> $LOGFILE
224	rm -f ${BINARCHIVE}
225	cd ${CODEMGR_WS}
226	filelist ${CODEMGR_WS} '^preserve:' >> $LOGFILE
227	filelist ${CODEMGR_WS} '^preserve:' | \
228	    cpio -ocB 2>/dev/null | compress \
229	    > ${BINARCHIVE}
230}
231
232# delete files
233# usage: hybridize_files DESTDIR MAKE_TARGET
234hybridize_files() {
235	DEST=$1
236	MAKETARG=$2
237
238	echo "\n==== Hybridizing files at `date` ====\n" | \
239	    tee -a $mail_msg_file >> $LOGFILE
240	for i in `filelist ${DEST} '^delete:'`
241	do
242		echo "removing ${i}." | tee -a $mail_msg_file >> $LOGFILE
243		rm -rf "${i}"
244	done
245	for i in `filelist ${DEST} '^hybridize:' `
246	do
247		echo "hybridizing ${i}." | tee -a $mail_msg_file >> $LOGFILE
248		rm -f ${i}+
249		sed -e "/^# HYBRID DELETE START/,/^# HYBRID DELETE END/d" \
250		    < ${i} > ${i}+
251		mv ${i}+ ${i}
252	done
253}
254
255# restore binaries into the proper source tree.
256# usage: restore_binaries DESTDIR MAKE_TARGET
257restore_binaries() {
258	DEST=$1
259	MAKETARG=$2
260
261	echo "\n==== Restoring binaries to ${MAKETARG} at `date` ====\n" | \
262	    tee -a $mail_msg_file >> $LOGFILE
263	cd ${DEST}
264	zcat ${BINARCHIVE} | \
265	    cpio -idmucvB 2>/dev/null | tee -a $mail_msg_file >> ${LOGFILE}
266}
267
268# rename files we save binaries of
269# usage: rename_files DESTDIR MAKE_TARGET
270rename_files() {
271	DEST=$1
272	MAKETARG=$2
273	echo "\n==== Renaming source files in ${MAKETARG} at `date` ====\n" | \
274	    tee -a $mail_msg_file >> $LOGFILE
275	for i in `filelist ${DEST} '^rename:'`
276	do
277		echo ${i} | tee -a $mail_msg_file >> ${LOGFILE}
278		rm -f ${i}.export
279		mv ${i} ${i}.export
280	done
281}
282
283#
284# Copy some or all of the source tree.
285#
286# Returns 0 for success, non-zero for failure.
287#
288# usage: copy_source CODEMGR_WS DESTDIR LABEL SRCROOT
289#
290copy_source() {
291	WS=$1
292	DEST=$2
293	label=$3
294	srcroot=$4
295
296	printf "\n==== Creating %s source from %s (%s) ====\n\n" \
297	    "$DEST" "$WS" "$label" | tee -a $mail_msg_file >> $LOGFILE
298
299	printf "cleaning out %s\n" "$DEST." >> $LOGFILE
300	rm -rf "$DEST" >> $LOGFILE 2>&1
301
302	printf "creating %s\n" "$DEST." >> $LOGFILE
303	mkdir -p "$DEST" 2>> $LOGFILE
304
305	if (( $? != 0 )) ; then
306		printf "failed to create %s\n" "$DEST" |
307		    tee -a $mail_msg_file >> $LOGFILE
308		build_ok=n
309		return 1
310	fi
311	cd "$WS"
312
313	printf "populating %s\n" "$DEST." >> $LOGFILE
314
315	case "$SCM_TYPE" in
316	teamware)
317		find $srcroot -name 's\.*' -a -type f -print | \
318		    sed -e 's,SCCS\/s.,,' | \
319		    grep -v '/\.del-*' | \
320		    cpio -pd $DEST >>$LOGFILE 2>&1
321		if (( $? != 0 )) ; then
322		    printf "cpio failed for %s\n" "$DEST" |
323			tee -a $mail_msg_file >> $LOGFILE
324		    build_ok=n
325		    return 1
326		fi
327		;;
328	mercurial)
329		copy_source_mercurial $DEST $srcroot
330		if (( $? != 0 )) ; then
331		    build_ok=n
332		    return 1
333		fi
334		;;
335	*)
336		build_ok=n
337		echo "Tree copy is not supported for workspace type" \
338		    "$SCM_TYPE" | tee -a $mail_msg_file >> $LOGFILE
339		return 1
340		;;
341	esac
342
343	return 0
344}
345
346#
347# Mercurial-specific copy code for copy_source().  Handles the
348# combined open and closed trees.
349#
350# Returns 0 for success, non-zero for failure.
351#
352# usage: copy_source_mercurial destdir srcroot
353#
354function copy_source_mercurial {
355	typeset dest=$1
356	typeset srcroot=$2
357	typeset open_top closed_top
358
359	case $srcroot in
360	usr)
361		open_top=usr
362		if [[ "$CLOSED_IS_PRESENT" = yes ]]; then
363			closed_top=usr/closed
364		fi
365		;;
366	usr/closed*)
367		if [[ "$CLOSED_IS_PRESENT" = no ]]; then
368			printf "can't copy %s: closed tree not present.\n" \
369			    "$srcroot" | tee -a $mail_msg_file >> $LOGFILE
370			return 1
371		fi
372		closed_top="$srcroot"
373		;;
374	*)
375		open_top="$srcroot"
376		;;
377	esac
378
379	if [[ -n "$open_top" ]]; then
380		hg locate -I "$open_top" | cpio -pd "$dest" >>$LOGFILE 2>&1
381		if (( $? != 0 )) ; then
382		    printf "cpio failed for %s\n" "$dest" |
383			tee -a $mail_msg_file >> $LOGFILE
384		    return 1
385		fi
386	fi
387
388	if [[ -n "$closed_top" ]]; then
389		mkdir -p "$dest/usr/closed" || return 1
390		if [[ "$closed_top" = usr/closed ]]; then
391			(cd usr/closed; hg locate |
392			    cpio -pd "$dest/usr/closed") >>$LOGFILE 2>&1
393			if (( $? != 0 )) ; then
394			    printf "cpio failed for %s/usr/closed\n" \
395				"$dest" | tee -a $mail_msg_file >> $LOGFILE
396			    return 1
397			fi
398		else
399			# copy subtree of usr/closed
400			closed_top=${closed_top#usr/closed/}
401			(cd usr/closed; hg locate -I "$closed_top" |
402			    cpio -pd "$dest/usr/closed") >>$LOGFILE 2>&1
403			if (( $? != 0 )) ; then
404			    printf "cpio failed for %s/usr/closed/%s\n" \
405				"$dest" "$closed_top" |
406				tee -a $mail_msg_file >> $LOGFILE
407			    return 1
408			fi
409		fi
410	fi
411
412	return 0
413}
414
415#
416# function to create (but not build) the export/crypt source tree.
417# usage: set_up_source_build CODEMGR_WS DESTDIR MAKE_TARGET
418# Sets SRC to the modified source tree, for use by the caller when it
419# builds the tree.
420#
421set_up_source_build() {
422	WS=$1
423	DEST=$2
424	MAKETARG=$3
425
426	copy_source $WS $DEST $MAKETARG usr
427	if (( $? != 0 )); then
428	    echo "\nCould not copy source tree for source build." |
429		tee -a $mail_msg_file >> $LOGFILE
430	    build_ok=n
431	    return
432	fi
433
434	SRC=${DEST}/usr/src
435
436	cd $SRC
437	rm -f ${MAKETARG}.out
438	echo "making ${MAKETARG} in ${SRC}." >> $LOGFILE
439	/bin/time $MAKE -e ${MAKETARG} 2>&1 | \
440	    tee -a $SRC/${MAKETARG}.out >> $LOGFILE
441	echo "\n==== ${MAKETARG} build errors ====\n" >> $mail_msg_file
442	egrep ":" $SRC/${MAKETARG}.out | \
443		egrep -e "(^${MAKE}:|[ 	]error[: 	\n])" | \
444		egrep -v "Ignoring unknown host" | \
445		egrep -v "warning" >> $mail_msg_file
446
447	echo "clearing state files." >> $LOGFILE
448	find . -name '.make*' -exec rm -f {} \;
449
450	cd ${DEST}
451	if [ "${MAKETARG}" = "CRYPT_SRC" ]; then
452		rm -f ${CODEMGR_WS}/crypt_files.cpio.Z
453		echo "\n==== xmod/cry_files that don't exist ====\n" | \
454		    tee -a $mail_msg_file >> $LOGFILE
455		CRYPT_FILES=${WS}/usr/src/xmod/cry_files
456		for i in `cat ${CRYPT_FILES}`
457		do
458			# make sure the files exist
459			if [ -f "$i" ]; then
460				continue
461			fi
462			if [ -d "$i" ]; then
463				continue
464			fi
465			echo "$i" | tee -a $mail_msg_file >> $LOGFILE
466		done
467		find `cat ${CRYPT_FILES}` -print 2>/dev/null | \
468		    cpio -ocB 2>/dev/null | \
469		    compress > ${CODEMGR_WS}/crypt_files.cpio.Z
470	fi
471
472	if [ "${MAKETARG}" = "EXPORT_SRC" ]; then
473		# rename first, since we might restore a file
474		# of the same name (mapfiles)
475		rename_files ${EXPORT_SRC} EXPORT_SRC
476		if [ "$SH_FLAG" = "y" ]; then
477			hybridize_files ${EXPORT_SRC} EXPORT_SRC
478		fi
479	fi
480
481	# save the cleartext
482	echo "\n==== Creating ${MAKETARG}.cpio.Z ====\n" | \
483	    tee -a $mail_msg_file >> $LOGFILE
484	cd ${DEST}
485	rm -f ${MAKETARG}.cpio.Z
486	find usr -depth -print | \
487	    grep -v usr/src/${MAKETARG}.out | \
488	    cpio -ocB 2>/dev/null | \
489	    compress > ${CODEMGR_WS}/${MAKETARG}.cpio.Z
490	if [ "${MAKETARG}" = "EXPORT_SRC" ]; then
491		restore_binaries ${EXPORT_SRC} EXPORT_SRC
492	fi
493
494	if [ "${MAKETARG}" = "CRYPT_SRC" ]; then
495		restore_binaries ${CRYPT_SRC} CRYPT_SRC
496	fi
497
498}
499
500# Return library search directive as function of given root.
501myldlibs() {
502	echo "-L$1/lib -L$1/usr/lib"
503}
504
505# Return header search directive as function of given root.
506myheaders() {
507	echo "-I$1/usr/include"
508}
509
510#
511# Wrapper over commands that generate BFU archives.  The entire
512# command output gets written to LOGFILE, and any unexpected messages
513# are written to the mail message.  Returns with the status of the
514# original command.
515#
516makebfu_filt() {
517	typeset tmplog
518	typeset errors
519	typeset cmd
520	integer cmd_stat
521
522	cmd="$1"
523	shift
524	tmplog="$TMPDIR/$cmd.out"
525	errors="$TMPDIR/$cmd-errors"
526	$cmd $* > "$tmplog" 2>&1
527	cmd_stat=$?
528	cat "$tmplog" >> "$LOGFILE"
529	grep -v "^Creating .* archive:" "$tmplog" | grep -v "^Making" | \
530	    grep -v "^$" | sort -u > "$errors"
531	if [[ -s "$errors" ]]; then
532		echo "\n==== cpio archives build errors ($LABEL) ====\n" \
533		    >> "$mail_msg_file"
534		cat "$errors" >> "$mail_msg_file"
535	fi
536	rm -f "$tmplog" "$errors"
537	return $cmd_stat
538}
539
540#
541# Function to do the build, including cpio archive and package generation.
542# usage: build LABEL SUFFIX MULTIPROTO
543# - LABEL is used to tag build output.
544# - SUFFIX is used to distinguish files (e.g., debug vs non-debug).
545# - If MULTIPROTO is "yes", it means to name the proto area according to
546#   SUFFIX.  Otherwise ("no"), (re)use the standard proto area.
547#
548build() {
549	LABEL=$1
550	SUFFIX=$2
551	MULTIPROTO=$3
552	INSTALLOG=install${SUFFIX}-${MACH}
553	NOISE=noise${SUFFIX}-${MACH}
554	CPIODIR=${CPIODIR_ORIG}${SUFFIX}
555	PKGARCHIVE=${PKGARCHIVE_ORIG}${SUFFIX}
556	if [ "$SPARC_RM_PKGARCHIVE_ORIG" ]; then
557		SPARC_RM_PKGARCHIVE=${SPARC_RM_PKGARCHIVE_ORIG}${SUFFIX}
558	fi
559
560	ORIGROOT=$ROOT
561	[ $MULTIPROTO = no ] || export ROOT=$ROOT$SUFFIX
562
563	export ENVLDLIBS1=`myldlibs $ROOT`
564	export ENVCPPFLAGS1=`myheaders $ROOT`
565
566	this_build_ok=y
567	#
568	#	Build OS-Networking source
569	#
570	echo "\n==== Building OS-Net source at `date` ($LABEL) ====\n" \
571		>> $LOGFILE
572
573	rm -f $SRC/${INSTALLOG}.out
574	cd $SRC
575	/bin/time $MAKE -e install 2>&1 | \
576	    tee -a $SRC/${INSTALLOG}.out >> $LOGFILE
577
578	if [[ "$SCM_TYPE" = teamware ]]; then
579		echo "\n==== SCCS Noise ($LABEL) ====\n" >> $mail_msg_file
580		egrep 'sccs(check:| *get)' $SRC/${INSTALLOG}.out >> \
581			$mail_msg_file
582	fi
583
584	echo "\n==== Build errors ($LABEL) ====\n" >> $mail_msg_file
585	egrep ":" $SRC/${INSTALLOG}.out |
586		egrep -e "(^${MAKE}:|[ 	]error[: 	\n])" | \
587		egrep -v "Ignoring unknown host" | \
588		egrep -v "cc .* -o error " | \
589		egrep -v "warning" >> $mail_msg_file
590	if [ "$?" = "0" ]; then
591		build_ok=n
592		this_build_ok=n
593	fi
594	grep "bootblock image is .* bytes too big" $SRC/${INSTALLOG}.out \
595		>> $mail_msg_file
596	if [ "$?" = "0" ]; then
597		build_ok=n
598		this_build_ok=n
599	fi
600
601	if [ "$W_FLAG" = "n" ]; then
602		echo "\n==== Build warnings ($LABEL) ====\n" >>$mail_msg_file
603		egrep -i warning: $SRC/${INSTALLOG}.out \
604			| egrep -v '^tic:' \
605			| egrep -v "symbol \`timezone' has differing types:" \
606		        | egrep -v "parameter <PSTAMP> set to" \
607			| egrep -v "Ignoring unknown host" \
608			| egrep -v "redefining segment flags attribute for" \
609			>> $mail_msg_file
610	fi
611
612	echo "\n==== Ended OS-Net source build at `date` ($LABEL) ====\n" \
613		>> $LOGFILE
614
615	echo "\n==== Elapsed build time ($LABEL) ====\n" >>$mail_msg_file
616	tail -3  $SRC/${INSTALLOG}.out >>$mail_msg_file
617
618	if [ "$i_FLAG" = "n" -a "$W_FLAG" = "n" ]; then
619		rm -f $SRC/${NOISE}.ref
620		if [ -f $SRC/${NOISE}.out ]; then
621			mv $SRC/${NOISE}.out $SRC/${NOISE}.ref
622		fi
623		grep : $SRC/${INSTALLOG}.out \
624			| egrep -v '^/' \
625			| egrep -v '^(Start|Finish|real|user|sys|./bld_awk)' \
626			| egrep -v '^tic:' \
627			| egrep -v '^mcs' \
628			| egrep -v '^LD_LIBRARY_PATH=' \
629			| egrep -v 'ar: creating' \
630			| egrep -v 'ar: writing' \
631			| egrep -v 'conflicts:' \
632			| egrep -v ':saved created' \
633			| egrep -v '^stty.*c:' \
634			| egrep -v '^mfgname.c:' \
635			| egrep -v '^uname-i.c:' \
636			| egrep -v '^volumes.c:' \
637			| egrep -v '^lint library construction:' \
638			| egrep -v 'tsort: INFORM:' \
639			| egrep -v 'stripalign:' \
640			| egrep -v 'chars, width' \
641			| egrep -v "symbol \`timezone' has differing types:" \
642			| egrep -v 'PSTAMP' \
643			| egrep -v '|%WHOANDWHERE%|' \
644			| egrep -v '^Manifying' \
645			| egrep -v 'Ignoring unknown host' \
646			| egrep -v 'Processing method:' \
647			| egrep -v '^Writing' \
648			| egrep -v 'spellin1:' \
649			| egrep -v '^adding:' \
650			| egrep -v "^echo 'msgid" \
651			| egrep -v '^echo ' \
652			| egrep -v '\.c:$' \
653			| egrep -v '^Adding file:' \
654			| egrep -v 'CLASSPATH=' \
655			| egrep -v '\/var\/mail\/:saved' \
656			| egrep -v -- '-DUTS_VERSION=' \
657			| egrep -v '^Running Mkbootstrap' \
658			| egrep -v '^Applet length read:' \
659			| egrep -v 'bytes written:' \
660			| egrep -v '^File:SolarisAuthApplet.bin' \
661			| egrep -v -i 'jibversion' \
662			| egrep -v '^Output size:' \
663			| egrep -v '^Solo size statistics:' \
664			| egrep -v '^Using ROM API Version' \
665			| egrep -v '^Zero Signature length:' \
666			| egrep -v '^Note \(probably harmless\):' \
667			| egrep -v '::' \
668			| egrep -v -- '-xcache' \
669			| egrep -v '^\+' \
670			| egrep -v '^cc1: note: -fwritable-strings' \
671			| egrep -v 'svccfg-native -s svc:/' \
672			| sort | uniq >$SRC/${NOISE}.out
673		if [ ! -f $SRC/${NOISE}.ref ]; then
674			cp $SRC/${NOISE}.out $SRC/${NOISE}.ref
675		fi
676		echo "\n==== Build noise differences ($LABEL) ====\n" \
677			>>$mail_msg_file
678		diff $SRC/${NOISE}.ref $SRC/${NOISE}.out >>$mail_msg_file
679	fi
680
681	#
682	#	Re-sign selected binaries using signing server
683	#	(gatekeeper builds only)
684	#
685	if [ -n "$CODESIGN_USER" -a "$this_build_ok" = "y" ]; then
686		echo "\n==== Signing proto area at `date` ====\n" >> $LOGFILE
687		signing_file="${TMPDIR}/signing"
688		rm -f ${signing_file}
689		export CODESIGN_USER
690		signproto $SRC/tools/codesign/creds 2>&1 | \
691			tee -a ${signing_file} >> $LOGFILE
692		echo "\n==== Finished signing proto area at `date` ====\n" \
693		    >> $LOGFILE
694		echo "\n==== Crypto module signing errors ($LABEL) ====\n" \
695		    >> $mail_msg_file
696		egrep 'WARNING|ERROR' ${signing_file} >> $mail_msg_file
697		if (( $? == 0 )) ; then
698			build_ok=n
699			this_build_ok=n
700		fi
701	fi
702
703	#
704	#	Create cpio archives for preintegration testing (PIT)
705	#
706	if [ "$a_FLAG" = "y" -a "$this_build_ok" = "y" ]; then
707		echo "\n==== Creating $LABEL cpio archives at `date` ====\n" \
708			>> $LOGFILE
709		makebfu_filt makebfu
710		# hack for test folks
711		if [ -z "`echo $PARENT_WS|egrep '^\/ws\/'`" ]; then
712			X=/net/`uname -n`${CPIODIR}
713		else
714			X=${CPIODIR}
715		fi
716		echo "Archive_directory: ${X}" >${TMPDIR}/f
717		cp ${TMPDIR}/f $(dirname $(dirname ${CPIODIR}))/.${MACH}_wgtrun
718		rm -f ${TMPDIR}/f
719
720	else
721		echo "\n==== Not creating $LABEL cpio archives ====\n" \
722			>> $LOGFILE
723	fi
724
725	#
726	#	Building Packages
727	#
728	if [ "$p_FLAG" = "y" -a "$this_build_ok" = "y" ]; then
729		echo "\n==== Creating $LABEL packages at `date` ====\n" \
730			>> $LOGFILE
731		rm -f $SRC/pkgdefs/${INSTALLOG}.out
732		echo "Clearing out $PKGARCHIVE ..." >> $LOGFILE
733		rm -rf $PKGARCHIVE
734		mkdir -p $PKGARCHIVE
735
736		#
737		# Optional build of sparc realmode on i386
738		#
739		if [ "$MACH" = "i386" ] && [ "${SPARC_RM_PKGARCHIVE}" ]; then
740			echo "Clearing out ${SPARC_RM_PKGARCHIVE} ..." \
741				>> $LOGFILE
742			rm -rf ${SPARC_RM_PKGARCHIVE}
743			mkdir -p ${SPARC_RM_PKGARCHIVE}
744		fi
745
746		cd $SRC/pkgdefs
747		$MAKE -e install 2>&1 | \
748			tee -a $SRC/pkgdefs/${INSTALLOG}.out >> $LOGFILE
749		echo "\n==== Package build errors ($LABEL) ====\n" \
750			>> $mail_msg_file
751		egrep "${MAKE}|ERROR|WARNING" $SRC/pkgdefs/${INSTALLOG}.out | \
752			grep ':' | \
753			grep -v PSTAMP | \
754			egrep -v "Ignoring unknown host" \
755			>> $mail_msg_file
756	else
757		echo "\n==== Not creating $LABEL packages ====\n" >> $LOGFILE
758	fi
759
760	ROOT=$ORIGROOT
761}
762
763# Usage: dolint /dir y|n
764# Arg. 2 is a flag to turn on/off the lint diff output
765dolint() {
766	if [ ! -d "$1" ]; then
767		echo "dolint error: $1 is not a directory"
768		exit 1
769	fi
770
771	if [ "$2" != "y" -a "$2" != "n" ]; then
772		echo "dolint internal error: $2 should be 'y' or 'n'"
773		exit 1
774	fi
775
776	lintdir=$1
777	dodiff=$2
778	base=`basename $lintdir`
779	LINTOUT=$lintdir/lint-${MACH}.out
780	LINTNOISE=$lintdir/lint-noise-${MACH}
781	export ENVLDLIBS1=`myldlibs $ROOT`
782	export ENVCPPFLAGS1=`myheaders $ROOT`
783
784	set_debug_build_flags
785
786	#
787	#	'$MAKE lint' in $lintdir
788	#
789	echo "\n==== Begin '$MAKE lint' of $base at `date` ====\n" >> $LOGFILE
790
791	# remove old lint.out
792	rm -f $lintdir/lint.out $lintdir/lint-noise.out
793	if [ -f $lintdir/lint-noise.ref ]; then
794		mv $lintdir/lint-noise.ref ${LINTNOISE}.ref
795	fi
796
797	rm -f $LINTOUT
798	cd $lintdir
799	#
800	# Remove all .ln files to ensure a full reference file
801	#
802	rm -f Nothing_to_remove \
803	    `find . \( -name SCCS -o -name .hg -o -name .svn \) \
804	    	-prune -o -type f -name '*.ln' -print `
805
806	/bin/time $MAKE -ek lint 2>&1 | \
807	    tee -a $LINTOUT >> $LOGFILE
808	echo "\n==== '$MAKE lint' of $base ERRORS ====\n" >> $mail_msg_file
809	grep "$MAKE:" $LINTOUT |
810		egrep -v "Ignoring unknown host" \
811		>> $mail_msg_file
812
813	echo "\n==== Ended '$MAKE lint' of $base at `date` ====\n" >> $LOGFILE
814
815	echo "\n==== Elapsed time of '$MAKE lint' of $base ====\n" \
816		>>$mail_msg_file
817	tail -3  $LINTOUT >>$mail_msg_file
818
819	rm -f ${LINTNOISE}.ref
820	if [ -f ${LINTNOISE}.out ]; then
821		mv ${LINTNOISE}.out ${LINTNOISE}.ref
822	fi
823        grep : $LINTOUT | \
824		egrep -v '^(real|user|sys)' |
825		egrep -v '(library construction)' | \
826		egrep -v ': global crosschecks' | \
827		egrep -v 'Ignoring unknown host' | \
828		egrep -v '\.c:$' | \
829		sort | uniq > ${LINTNOISE}.out
830	if [ ! -f ${LINTNOISE}.ref ]; then
831		cp ${LINTNOISE}.out ${LINTNOISE}.ref
832	fi
833	if [ "$dodiff" != "n" ]; then
834		echo "\n==== lint warnings $base ====\n" \
835			>>$mail_msg_file
836		# should be none, though there are a few that were filtered out
837		# above
838		egrep -i '(warning|lint):' ${LINTNOISE}.out \
839			| sort | uniq >> $mail_msg_file
840		echo "\n==== lint noise differences $base ====\n" \
841			>> $mail_msg_file
842		diff ${LINTNOISE}.ref ${LINTNOISE}.out \
843			>> $mail_msg_file
844	fi
845}
846
847# Install proto area from IHV build
848
849copy_ihv_proto() {
850
851	echo "\n==== Installing IHV proto area ====\n" \
852		>> $LOGFILE
853	if [ -d "$IA32_IHV_ROOT" ]; then
854		if [ ! -d "$ROOT" ]; then
855			echo "mkdir -p $ROOT" >> $LOGFILE
856			mkdir -p $ROOT
857		fi
858		echo "copying $IA32_IHV_ROOT to $ROOT\n" >> $LOGFILE
859		cd $IA32_IHV_ROOT
860		tar -cf - . | (cd $ROOT; umask 0; tar xpf - ) 2>&1 >> $LOGFILE
861	else
862		echo "$IA32_IHV_ROOT: not found" >> $LOGFILE
863	fi
864
865	if [ "$MULTI_PROTO" = yes ]; then
866		if [ ! -d "$ROOT-nd" ]; then
867			echo "mkdir -p $ROOT-nd" >> $LOGFILE
868			mkdir -p $ROOT-nd
869		fi
870		# If there's a non-debug version of the IHV proto area,
871		# copy it, but copy something if there's not.
872		if [ -d "$IA32_IHV_ROOT-nd" ]; then
873			echo "copying $IA32_IHV_ROOT-nd to $ROOT-nd\n" >> $LOGFILE
874			cd $IA32_IHV_ROOT-nd
875		elif [ -d "$IA32_IHV_ROOT" ]; then
876			echo "copying $IA32_IHV_ROOT to $ROOT-nd\n" >> $LOGFILE
877			cd $IA32_IHV_ROOT
878		else
879			echo "$IA32_IHV_ROOT{-nd,}: not found" >> $LOGFILE
880			return
881		fi
882		tar -cf - . | (cd $ROOT-nd; umask 0; tar xpf - ) 2>&1 >> $LOGFILE
883	fi
884}
885
886# Install IHV packages in PKGARCHIVE
887# usage: copy_ihv_pkgs LABEL SUFFIX
888copy_ihv_pkgs() {
889	LABEL=$1
890	SUFFIX=$2
891	# always use non-DEBUG IHV packages
892	IA32_IHV_PKGS=${IA32_IHV_PKGS_ORIG}-nd
893	PKGARCHIVE=${PKGARCHIVE_ORIG}${SUFFIX}
894
895	echo "\n==== Installing IHV packages from $IA32_IHV_PKGS ($LABEL) ====\n" \
896		>> $LOGFILE
897	if [ -d "$IA32_IHV_PKGS" ]; then
898		cd $IA32_IHV_PKGS
899		tar -cf - * | \
900		   (cd $PKGARCHIVE; umask 0; tar xpf - ) 2>&1 >> $LOGFILE
901	else
902		echo "$IA32_IHV_PKGS: not found" >> $LOGFILE
903	fi
904
905	echo "\n==== Installing IHV packages from $IA32_IHV_BINARY_PKGS ($LABEL) ====\n" \
906		>> $LOGFILE
907	if [ -d "$IA32_IHV_BINARY_PKGS" ]; then
908		cd $IA32_IHV_BINARY_PKGS
909		tar -cf - * | \
910		    (cd $PKGARCHIVE; umask 0; tar xpf - ) 2>&1 >> $LOGFILE
911	else
912		echo "$IA32_IHV_BINARY_PKGS: not found" >> $LOGFILE
913	fi
914}
915
916#
917# Build and install the onbld tools.
918#
919# usage: build_tools DESTROOT
920#
921# returns non-zero status if the build was successful.
922#
923build_tools() {
924	DESTROOT=$1
925
926	INSTALLOG=install-${MACH}
927
928	echo "\n==== Building tools at `date` ====\n" \
929		>> $LOGFILE
930
931	rm -f ${TOOLS}/${INSTALLOG}.out
932	cd ${TOOLS}
933	/bin/time $MAKE ROOT=${DESTROOT} -e install 2>&1 | \
934	    tee -a ${TOOLS}/${INSTALLOG}.out >> $LOGFILE
935
936	echo "\n==== Tools build errors ====\n" >> $mail_msg_file
937
938	egrep ":" ${TOOLS}/${INSTALLOG}.out |
939		egrep -e "(${MAKE}:|[ 	]error[: 	\n])" | \
940		egrep -v "Ignoring unknown host" | \
941		egrep -v warning >> $mail_msg_file
942	return $?
943}
944
945#
946# Set up to use locally installed tools.
947#
948# usage: use_tools TOOLSROOT
949#
950use_tools() {
951	TOOLSROOT=$1
952
953	STABS=${TOOLSROOT}/opt/onbld/bin/${MACH}/stabs
954	export STABS
955	CTFSTABS=${TOOLSROOT}/opt/onbld/bin/${MACH}/ctfstabs
956	export CTFSTABS
957	GENOFFSETS=${TOOLSROOT}/opt/onbld/bin/genoffsets
958	export GENOFFSETS
959
960	CTFCONVERT=${TOOLSROOT}/opt/onbld/bin/${MACH}/ctfconvert
961	export CTFCONVERT
962	CTFMERGE=${TOOLSROOT}/opt/onbld/bin/${MACH}/ctfmerge
963	export CTFMERGE
964
965	CTFCVTPTBL=${TOOLSROOT}/opt/onbld/bin/ctfcvtptbl
966	export CTFCVTPTBL
967	CTFFINDMOD=${TOOLSROOT}/opt/onbld/bin/ctffindmod
968	export CTFFINDMOD
969
970	if [ "$VERIFY_ELFSIGN" = "y" ]; then
971		ELFSIGN=${TOOLSROOT}/opt/onbld/bin/elfsigncmp
972	else
973		ELFSIGN=${TOOLSROOT}/opt/onbld/bin/${MACH}/elfsign
974	fi
975	export ELFSIGN
976
977	PATH="${TOOLSROOT}/opt/onbld/bin/${MACH}:${PATH}"
978	PATH="${TOOLSROOT}/opt/onbld/bin:${PATH}"
979	export PATH
980
981	echo "\n==== New environment settings. ====\n" >> $LOGFILE
982	echo "STABS=${STABS}" >> $LOGFILE
983	echo "CTFSTABS=${CTFSTABS}" >> $LOGFILE
984	echo "CTFCONVERT=${CTFCONVERT}" >> $LOGFILE
985	echo "CTFMERGE=${CTFMERGE}" >> $LOGFILE
986	echo "CTFCVTPTBL=${CTFCVTPTBL}" >> $LOGFILE
987	echo "CTFFINDMOD=${CTFFINDMOD}" >> $LOGFILE
988	echo "ELFSIGN=${ELFSIGN}" >> $LOGFILE
989	echo "PATH=${PATH}" >> $LOGFILE
990}
991
992staffer() {
993	if [ $ISUSER -ne 0 ]; then
994		"$@"
995	else
996		arg="\"$1\""
997		shift
998		for i
999		do
1000			arg="$arg \"$i\""
1001		done
1002		eval su $STAFFER -c \'$arg\'
1003	fi
1004}
1005
1006#
1007# Verify that the closed tree is present if it needs to be.
1008# Sets CLOSED_IS_PRESENT for future use.
1009#
1010check_closed_tree() {
1011	if [ -z "$CLOSED_IS_PRESENT" ]; then
1012		if [ -d $CODEMGR_WS/usr/closed ]; then
1013			CLOSED_IS_PRESENT="yes"
1014		else
1015			CLOSED_IS_PRESENT="no"
1016		fi
1017		export CLOSED_IS_PRESENT
1018	fi
1019	if [[ "$CLOSED_IS_PRESENT" = no && ! -d "$ON_CLOSED_BINS" ]]; then
1020		#
1021		# If it's an old (pre-split) tree or an empty
1022		# workspace, don't complain.
1023		#
1024		if grep -s CLOSED_BUILD $SRC/Makefile.master > /dev/null; then
1025			echo "If the closed sources are not present," \
1026			    "ON_CLOSED_BINS"
1027			echo "must point to the closed binaries tree."
1028			build_ok=n
1029			exit 1
1030		fi
1031	fi
1032}
1033
1034obsolete_build() {
1035    	echo "WARNING: Obsolete $1 build requested; request will be ignored"
1036}
1037
1038#
1039# wrapper over wsdiff.
1040# usage: do_wsdiff LABEL OLDPROTO NEWPROTO
1041#
1042do_wsdiff() {
1043	label=$1
1044	oldproto=$2
1045	newproto=$3
1046
1047	echo "\n==== Objects that differ since last build ($label) ====\n" | \
1048	    tee -a $LOGFILE >> $mail_msg_file
1049
1050	wsdiff="wsdiff"
1051	[ "$t_FLAG" = y ] && wsdiff="wsdiff -t"
1052
1053	$wsdiff -r ${TMPDIR}/wsdiff.results $oldproto $newproto 2>&1 | \
1054		    tee -a $LOGFILE >> $mail_msg_file
1055}
1056
1057#
1058# Functions for setting build flags (debug/non-debug).  Keep them
1059# together.
1060#
1061
1062set_non_debug_build_flags() {
1063	export INTERNAL_RELEASE_BUILD ; INTERNAL_RELEASE_BUILD=
1064	export RELEASE_BUILD ; RELEASE_BUILD=
1065	unset EXTRA_OPTIONS
1066	unset EXTRA_CFLAGS
1067}
1068
1069set_debug_build_flags() {
1070	export INTERNAL_RELEASE_BUILD ; INTERNAL_RELEASE_BUILD=
1071	unset RELEASE_BUILD
1072	unset EXTRA_OPTIONS
1073	unset EXTRA_CFLAGS
1074}
1075
1076
1077MACH=`uname -p`
1078
1079if [ "$OPTHOME" = "" ]; then
1080	OPTHOME=/opt
1081	export OPTHOME
1082fi
1083if [ "$TEAMWARE" = "" ]; then
1084	TEAMWARE=$OPTHOME/teamware
1085	export TEAMWARE
1086fi
1087
1088USAGE='Usage: nightly [-in] [-V VERS ] [ -S E|D|H|O ] <env_file>
1089
1090Where:
1091	-i	Fast incremental options (no clobber, lint, check)
1092	-n      Do not do a bringover
1093	-V VERS set the build version string to VERS
1094	-S	Build a variant of the source product
1095		E - build exportable source
1096		D - build domestic source (exportable + crypt)
1097		H - build hybrid source (binaries + deleted source)
1098		O - build (only) open source
1099
1100	<env_file>  file in Bourne shell syntax that sets and exports
1101	variables that configure the operation of this script and many of
1102	the scripts this one calls. If <env_file> does not exist,
1103	it will be looked for in $OPTHOME/onbld/env.
1104
1105non-DEBUG is the default build type. Build options can be set in the
1106NIGHTLY_OPTIONS variable in the <env_file> as follows:
1107
1108	-A	check for ABI differences in .so files
1109	-C	check for cstyle/hdrchk errors
1110	-D	do a build with DEBUG on
1111	-F	do _not_ do a non-DEBUG build
1112	-G	gate keeper default group of options (-au)
1113	-I	integration engineer default group of options (-ampu)
1114	-M	do not run pmodes (safe file permission checker)
1115	-N	do not run protocmp
1116	-O	generate OpenSolaris deliverables
1117	-R	default group of options for building a release (-mp)
1118	-U	update proto area in the parent
1119	-V VERS set the build version string to VERS
1120	-X	copy x86 IHV proto area
1121	-a	create cpio archives
1122	-f	find unreferenced files
1123	-i	do an incremental build (no "make clobber")
1124	-l	do "make lint" in $LINTDIRS (default: $SRC y)
1125	-m	send mail to $MAILTO at end of build
1126	-n      do not do a bringover
1127	-o	build using root privileges to set OWNER/GROUP (old style)
1128	-p	create packages
1129	-r	check ELF runtime attributes in the proto area
1130	-t	build and use the tools in $SRC/tools
1131	-u	update proto_list_$MACH and friends in the parent workspace;
1132		when used with -f, also build an unrefmaster.out in the parent
1133	-w	report on differences between previous and current proto areas
1134	-z	compress cpio archives with gzip
1135	-W	Do not report warnings (freeware gate ONLY)
1136	-S	Build a variant of the source product
1137		E - build exportable source
1138		D - build domestic source (exportable + crypt)
1139		H - build hybrid source (binaries + deleted source)
1140		O - build (only) open source
1141'
1142#
1143#	-x	less public handling of xmod source for the source product
1144#
1145#	A log file will be generated under the name $LOGFILE
1146#	for partially completed build and log.`date '+%F'`
1147#	in the same directory for fully completed builds.
1148#
1149
1150# default values for low-level FLAGS; G I R are group FLAGS
1151A_FLAG=n
1152a_FLAG=n
1153C_FLAG=n
1154D_FLAG=n
1155F_FLAG=n
1156f_FLAG=n
1157i_FLAG=n; i_CMD_LINE_FLAG=n
1158l_FLAG=n
1159M_FLAG=n
1160m_FLAG=n
1161N_FLAG=n
1162n_FLAG=n
1163O_FLAG=n
1164o_FLAG=n
1165P_FLAG=n
1166p_FLAG=n
1167r_FLAG=n
1168T_FLAG=n
1169t_FLAG=y
1170U_FLAG=n
1171u_FLAG=n
1172V_FLAG=n
1173W_FLAG=n
1174w_FLAG=n
1175X_FLAG=n
1176z_FLAG=n
1177SD_FLAG=n
1178SE_FLAG=n
1179SH_FLAG=n
1180SO_FLAG=n
1181#
1182XMOD_OPT=
1183#
1184build_ok=y
1185
1186is_source_build() {
1187	[ "$SE_FLAG" = "y" -o "$SD_FLAG" = "y" -o \
1188	    "$SH_FLAG" = "y" -o "$SO_FLAG" = "y" ]
1189	return $?
1190}
1191
1192#
1193# examine arguments
1194#
1195
1196#
1197# single function for setting -S flag and doing error checking.
1198# usage: set_S_flag <type>
1199# where <type> is the source build type ("E", "D", ...).
1200#
1201set_S_flag() {
1202	if is_source_build; then
1203		echo "Can only build one source variant at a time."
1204		exit 1
1205	fi
1206	if [ "$1" = "E" ]; then
1207		SE_FLAG=y
1208	elif [ "$1" = "D" ]; then
1209		SD_FLAG=y
1210	elif [ "$1" = "H" ]; then
1211		SH_FLAG=y
1212	elif [ "$1" = "O" ]; then
1213		SO_FLAG=y
1214	else
1215		echo "$USAGE"
1216		exit 1
1217	fi
1218}
1219
1220OPTIND=1
1221while getopts inS:tV: FLAG
1222do
1223	case $FLAG in
1224	  i )	i_FLAG=y; i_CMD_LINE_FLAG=y
1225		;;
1226	  n )	n_FLAG=y
1227		;;
1228	  S )
1229		set_S_flag $OPTARG
1230		;;
1231	 +t )	t_FLAG=n
1232		;;
1233	  V )	V_FLAG=y
1234		V_ARG="$OPTARG"
1235		;;
1236	 \? )	echo "$USAGE"
1237		exit 1
1238		;;
1239	esac
1240done
1241
1242# correct argument count after options
1243shift `expr $OPTIND - 1`
1244
1245# test that the path to the environment-setting file was given
1246if [ $# -ne 1 ]; then
1247	echo "$USAGE"
1248	exit 1
1249fi
1250
1251# check if user is running nightly as root
1252# ISUSER is set non-zero if an ordinary user runs nightly, or is zero
1253# when root invokes nightly.
1254/usr/bin/id | grep '^uid=0(' >/dev/null 2>&1
1255ISUSER=$?;	export ISUSER
1256
1257#
1258# force locale to C
1259LC_COLLATE=C;	export LC_COLLATE
1260LC_CTYPE=C;	export LC_CTYPE
1261LC_MESSAGES=C;	export LC_MESSAGES
1262LC_MONETARY=C;	export LC_MONETARY
1263LC_NUMERIC=C;	export LC_NUMERIC
1264LC_TIME=C;	export LC_TIME
1265
1266# clear environment variables we know to be bad for the build
1267unset LD_OPTIONS
1268unset LD_AUDIT		LD_AUDIT_32		LD_AUDIT_64
1269unset LD_BIND_NOW	LD_BIND_NOW_32		LD_BIND_NOW_64
1270unset LD_BREADTH	LD_BREADTH_32		LD_BREADTH_64
1271unset LD_CONFIG		LD_CONFIG_32		LD_CONFIG_64
1272unset LD_DEBUG		LD_DEBUG_32		LD_DEBUG_64
1273unset LD_DEMANGLE	LD_DEMANGLE_32		LD_DEMANGLE_64
1274unset LD_FLAGS		LD_FLAGS_32		LD_FLAGS_64
1275unset LD_LIBRARY_PATH	LD_LIBRARY_PATH_32	LD_LIBRARY_PATH_64
1276unset LD_LOADFLTR	LD_LOADFLTR_32		LD_LOADFLTR_64
1277unset LD_NOAUDIT	LD_NOAUDIT_32		LD_NOAUDIT_64
1278unset LD_NOAUXFLTR	LD_NOAUXFLTR_32		LD_NOAUXFLTR_64
1279unset LD_NOCONFIG	LD_NOCONFIG_32		LD_NOCONFIG_64
1280unset LD_NODIRCONFIG	LD_NODIRCONFIG_32	LD_NODIRCONFIG_64
1281unset LD_NODIRECT	LD_NODIRECT_32		LD_NODIRECT_64
1282unset LD_NOLAZYLOAD	LD_NOLAZYLOAD_32	LD_NOLAZYLOAD_64
1283unset LD_NOOBJALTER	LD_NOOBJALTER_32	LD_NOOBJALTER_64
1284unset LD_NOVERSION	LD_NOVERSION_32		LD_NOVERSION_64
1285unset LD_ORIGIN		LD_ORIGIN_32		LD_ORIGIN_64
1286unset LD_PRELOAD	LD_PRELOAD_32		LD_PRELOAD_64
1287unset LD_PROFILE	LD_PROFILE_32		LD_PROFILE_64
1288
1289unset CONFIG
1290unset GROUP
1291unset OWNER
1292unset REMOTE
1293unset ENV
1294unset ARCH
1295unset CLASSPATH
1296unset NAME
1297
1298#
1299#	Setup environmental variables
1300#
1301if [ -f /etc/nightly.conf ]; then
1302	. /etc/nightly.conf
1303fi
1304
1305if [ -f $1 ]; then
1306	if [[ $1 = */* ]]; then
1307		. $1
1308	else
1309		. ./$1
1310	fi
1311else
1312	if [ -f $OPTHOME/onbld/env/$1 ]; then
1313		. $OPTHOME/onbld/env/$1
1314	else
1315		echo "Cannot find env file as either $1 or $OPTHOME/onbld/env/$1"
1316		exit 1
1317	fi
1318fi
1319
1320# contents of stdenv.sh inserted after next line:
1321# STDENV_START
1322# STDENV_END
1323
1324#
1325# place ourselves in a new task, respecting BUILD_PROJECT if set.
1326#
1327if [ -z "$BUILD_PROJECT" ]; then
1328	/usr/bin/newtask -c $$
1329else
1330	/usr/bin/newtask -c $$ -p $BUILD_PROJECT
1331fi
1332
1333ps -o taskid= -p $$ | read build_taskid
1334ps -o project= -p $$ | read build_project
1335
1336#
1337# See if NIGHTLY_OPTIONS is set
1338#
1339if [ "$NIGHTLY_OPTIONS" = "" ]; then
1340	NIGHTLY_OPTIONS="-aBm"
1341fi
1342
1343#
1344# If BRINGOVER_WS was not specified, let it default to CLONE_WS
1345#
1346if [ "$BRINGOVER_WS" = "" ]; then
1347	BRINGOVER_WS=$CLONE_WS
1348fi
1349
1350#
1351# If CLOSED_BRINGOVER_WS was not specified, let it default to CLOSED_CLONE_WS
1352#
1353if [ "$CLOSED_BRINGOVER_WS" = "" ]; then
1354	CLOSED_BRINGOVER_WS=$CLOSED_CLONE_WS
1355fi
1356
1357#
1358# If BRINGOVER_FILES was not specified, default to usr
1359#
1360if [ "$BRINGOVER_FILES" = "" ]; then
1361	BRINGOVER_FILES="usr"
1362fi
1363
1364#
1365# If the closed sources are not present, the closed binaries must be
1366# present for the build to succeed.  If there's no pointer to the
1367# closed binaries, flag that now, rather than forcing the user to wait
1368# a couple hours (or more) to find out.
1369#
1370orig_closed_is_present="$CLOSED_IS_PRESENT"
1371check_closed_tree
1372
1373#
1374# Note: changes to the option letters here should also be applied to the
1375#	bldenv script.  `d' is listed for backward compatibility.
1376#
1377NIGHTLY_OPTIONS=-${NIGHTLY_OPTIONS#-}
1378OPTIND=1
1379while getopts AaBCDdFfGIilMmNnOoPpRrS:TtUuWwXxz FLAG $NIGHTLY_OPTIONS
1380do
1381	case $FLAG in
1382	  A )	A_FLAG=y
1383		;;
1384	  a )	a_FLAG=y
1385		;;
1386	  B )	D_FLAG=y
1387		;; # old version of D
1388	  C )	C_FLAG=y
1389		;;
1390	  D )	D_FLAG=y
1391		;;
1392	  F )	F_FLAG=y
1393		;;
1394	  f )	f_FLAG=y
1395		;;
1396	  G )	a_FLAG=y
1397		u_FLAG=y
1398		;;
1399	  I )	a_FLAG=y
1400		m_FLAG=y
1401		p_FLAG=y
1402		u_FLAG=y
1403		;;
1404	  i )	i_FLAG=y
1405		;;
1406	  l )	l_FLAG=y
1407		;;
1408	  M )	M_FLAG=y
1409		;;
1410	  m )	m_FLAG=y
1411		;;
1412	  N )	N_FLAG=y
1413		;;
1414	  n )	n_FLAG=y
1415		;;
1416	  O )	O_FLAG=y
1417		;;
1418	  o )	o_FLAG=y
1419		;;
1420	  P )	P_FLAG=y
1421		;; # obsolete
1422	  p )	p_FLAG=y
1423		;;
1424	  R )	m_FLAG=y
1425		p_FLAG=y
1426		;;
1427	  r )	r_FLAG=y
1428		;;
1429	  S )
1430		set_S_flag $OPTARG
1431		;;
1432	  T )	T_FLAG=y
1433		;; # obsolete
1434	 +t )	t_FLAG=n
1435		;;
1436	  U )
1437		if [ -z "${PARENT_ROOT}" ]; then
1438			echo "PARENT_ROOT must be set if the U flag is" \
1439			    "present in NIGHTLY_OPTIONS."
1440			exit 1
1441		fi
1442		U_FLAG=y
1443		NIGHTLY_PARENT_ROOT=$PARENT_ROOT
1444		;;
1445	  u )	u_FLAG=y
1446		;;
1447	  W )	W_FLAG=y
1448		;;
1449
1450	  w )	w_FLAG=y
1451		;;
1452	  X )	# now that we no longer need realmode builds, just
1453		# copy IHV packages.  only meaningful on x86.
1454		if [ "$MACH" = "i386" ]; then
1455			X_FLAG=y
1456		fi
1457		;;
1458	  x )	XMOD_OPT="-x"
1459		;;
1460	  z )	z_FLAG=y
1461		;;
1462	 \? )	echo "$USAGE"
1463		exit 1
1464		;;
1465	esac
1466done
1467
1468if [ $ISUSER -ne 0 ]; then
1469	if [ "$o_FLAG" = "y" ]; then
1470		echo "Old-style build requires root permission."
1471		exit 1
1472	fi
1473
1474	# Set default value for STAFFER, if needed.
1475	if [ -z "$STAFFER" -o "$STAFFER" = "nobody" ]; then
1476		STAFFER=`/usr/xpg4/bin/id -un`
1477		export STAFFER
1478	fi
1479fi
1480
1481if [ -z "$MAILTO" -o "$MAILTO" = "nobody" ]; then
1482	MAILTO=$STAFFER
1483	export MAILTO
1484fi
1485
1486PATH="$OPTHOME/onbld/bin:$OPTHOME/onbld/bin/${MACH}:/usr/ccs/bin"
1487PATH="$PATH:$OPTHOME/SUNWspro/bin:$TEAMWARE/bin:/usr/bin:/usr/sbin:/usr/ucb"
1488PATH="$PATH:/usr/openwin/bin:/usr/sfw/bin:/opt/sfw/bin:."
1489export PATH
1490
1491# roots of source trees, both relative to $SRC and absolute.
1492relsrcdirs="."
1493if [[ -d $CODEMGR_WS/usr/closed && "$CLOSED_IS_PRESENT" != no ]]; then
1494	relsrcdirs="$relsrcdirs ../closed"
1495fi
1496abssrcdirs=""
1497for d in $relsrcdirs; do
1498	abssrcdirs="$abssrcdirs $SRC/$d"
1499done
1500
1501unset CH
1502if [ "$o_FLAG" = "y" ]; then
1503# root invoked old-style build -- make sure it works as it always has
1504# by exporting 'CH'.  The current Makefile.master doesn't use this, but
1505# the old ones still do.
1506	PROTOCMPTERSE="protocmp.terse"
1507	CH=
1508	export CH
1509else
1510	PROTOCMPTERSE="protocmp.terse -gu"
1511fi
1512POUND_SIGN="#"
1513
1514# we export POUND_SIGN to speed up the build process -- prevents evaluation of
1515# the Makefile.master definitions.
1516export o_FLAG X_FLAG POUND_SIGN
1517
1518maketype="distributed"
1519MAKE=dmake
1520# get the dmake version string alone
1521DMAKE_VERSION=$( $MAKE -v )
1522DMAKE_VERSION=${DMAKE_VERSION#*: }
1523# focus in on just the dotted version number alone
1524DMAKE_MAJOR=$( echo $DMAKE_VERSION | \
1525	sed -e 's/.*\<\([^.]*\.[^   ]*\).*$/\1/' )
1526# extract the second (or final) integer
1527DMAKE_MINOR=${DMAKE_MAJOR#*.}
1528DMAKE_MINOR=${DMAKE_MINOR%%.*}
1529# extract the first integer
1530DMAKE_MAJOR=${DMAKE_MAJOR%%.*}
1531CHECK_DMAKE=${CHECK_DMAKE:-y}
1532# x86 was built on the 12th, sparc on the 13th.
1533if [ "$CHECK_DMAKE" = "y" -a \
1534     "$DMAKE_VERSION" != "Sun Distributed Make 7.3 2003/03/12" -a \
1535     "$DMAKE_VERSION" != "Sun Distributed Make 7.3 2003/03/13" -a \( \
1536     "$DMAKE_MAJOR" -lt 7 -o \
1537     "$DMAKE_MAJOR" -eq 7 -a "$DMAKE_MINOR" -lt 4 \) ]; then
1538	if [ -z "$DMAKE_VERSION" ]; then
1539		echo "$MAKE is missing."
1540		exit 1
1541	fi
1542	echo `whence $MAKE`" version is:"
1543	echo "  ${DMAKE_VERSION}"
1544	cat <<EOF
1545
1546This version may not be safe for use.  Either set TEAMWARE to a better
1547path or (if you really want to use this version of dmake anyway), add
1548the following to your environment to disable this check:
1549
1550  CHECK_DMAKE=n
1551EOF
1552	exit 1
1553fi
1554export PATH
1555export MAKE
1556
1557if [ "${SUNWSPRO}" != "" ]; then
1558	PATH="${SUNWSPRO}/bin:$PATH"
1559	export PATH
1560fi
1561
1562hostname=`uname -n`
1563if [ ! -f $HOME/.make.machines ]; then
1564	DMAKE_MAX_JOBS=4
1565else
1566	DMAKE_MAX_JOBS="`grep $hostname $HOME/.make.machines | \
1567	    tail -1 | awk -F= '{print $ 2;}'`"
1568	if [ "$DMAKE_MAX_JOBS" = "" ]; then
1569		DMAKE_MAX_JOBS=4
1570	fi
1571fi
1572DMAKE_MODE=parallel;
1573export DMAKE_MODE
1574export DMAKE_MAX_JOBS
1575
1576if [ -z "${ROOT}" ]; then
1577	echo "ROOT must be set."
1578	exit 1
1579fi
1580
1581#
1582# if -V flag was given, reset VERSION to V_ARG
1583#
1584if [ "$V_FLAG" = "y" ]; then
1585	VERSION=$V_ARG
1586fi
1587
1588#
1589# Check for IHV root for copying ihv proto area
1590#
1591if [ "$X_FLAG" = "y" ]; then
1592        if [ "$IA32_IHV_ROOT" = "" ]; then
1593		echo "IA32_IHV_ROOT: must be set for copying ihv proto"
1594		args_ok=n
1595        fi
1596        if [ ! -d "$IA32_IHV_ROOT" ]; then
1597                echo "$IA32_IHV_ROOT: not found"
1598                args_ok=n
1599        fi
1600        if [ "$IA32_IHV_WS" = "" ]; then
1601		echo "IA32_IHV_WS: must be set for copying ihv proto"
1602		args_ok=n
1603        fi
1604        if [ ! -d "$IA32_IHV_WS" ]; then
1605                echo "$IA32_IHV_WS: not found"
1606                args_ok=n
1607        fi
1608fi
1609
1610# Append source version
1611if [ "$SE_FLAG" = "y" ]; then
1612	VERSION="${VERSION}:EXPORT"
1613fi
1614
1615if [ "$SD_FLAG" = "y" ]; then
1616	VERSION="${VERSION}:DOMESTIC"
1617fi
1618
1619if [ "$SH_FLAG" = "y" ]; then
1620	VERSION="${VERSION}:MODIFIED_SOURCE_PRODUCT"
1621fi
1622
1623if [ "$SO_FLAG" = "y" ]; then
1624	VERSION="${VERSION}:OPEN_ONLY"
1625fi
1626
1627TMPDIR="/tmp/nightly.tmpdir.$$"
1628export TMPDIR
1629rm -rf ${TMPDIR}
1630mkdir -p $TMPDIR || exit 1
1631
1632#
1633# Keep elfsign's use of pkcs11_softtoken from looking in the user home
1634# directory, which doesn't always work.   Needed until all build machines
1635# have the fix for 6271754
1636#
1637SOFTTOKEN_DIR=$TMPDIR
1638export SOFTTOKEN_DIR
1639
1640TOOLS=${SRC}/tools
1641TOOLS_PROTO=${TOOLS}/proto
1642
1643unset   CFLAGS LD_LIBRARY_PATH LDFLAGS
1644
1645# create directories that are automatically removed if the nightly script
1646# fails to start correctly
1647newdir() {
1648	dir=$1
1649	toadd=
1650	while [ ! -d $dir ]; do
1651		toadd="$dir $toadd"
1652		dir=`dirname $dir`
1653	done
1654	torm=
1655	newlist=
1656	for dir in $toadd; do
1657		if staffer mkdir $dir; then
1658			newlist="$ISUSER $dir $newlist"
1659			torm="$dir $torm"
1660		else
1661			[ -z "$torm" ] || staffer rmdir $torm
1662			return 1
1663		fi
1664	done
1665	newdirlist="$newlist $newdirlist"
1666	return 0
1667}
1668newdirlist=
1669
1670[ -d $CODEMGR_WS ] || newdir $CODEMGR_WS || exit 1
1671
1672# since this script assumes the build is from full source, it nullifies
1673# variables likely to have been set by a "ws" script; nullification
1674# confines the search space for headers and libraries to the proto area
1675# built from this immediate source.
1676ENVLDLIBS1=
1677ENVLDLIBS2=
1678ENVLDLIBS3=
1679ENVCPPFLAGS1=
1680ENVCPPFLAGS2=
1681ENVCPPFLAGS3=
1682ENVCPPFLAGS4=
1683PARENT_ROOT=
1684
1685export ENVLDLIBS3 ENVCPPFLAGS1 ENVCPPFLAGS2 ENVCPPFLAGS3 ENVCPPFLAGS4 \
1686	PARENT_ROOT
1687
1688CPIODIR_ORIG=$CPIODIR
1689PKGARCHIVE_ORIG=$PKGARCHIVE
1690IA32_IHV_PKGS_ORIG=$IA32_IHV_PKGS
1691if [ "$SPARC_RM_PKGARCHIVE" ]; then
1692	SPARC_RM_PKGARCHIVE_ORIG=$SPARC_RM_PKGARCHIVE
1693fi
1694
1695#
1696# Juggle the logs and optionally send mail on completion.
1697#
1698
1699logshuffle() {
1700    	LLOG="$ATLOG/log.`date '+%F.%H:%M'`"
1701	if [ -f $LLOG -o -d $LLOG ]; then
1702	    	LLOG=$LLOG.$$
1703	fi
1704	mkdir $LLOG
1705	export LLOG
1706
1707	if [ "$build_ok" = "y" ]; then
1708		mv $ATLOG/proto_list_${MACH} $LLOG
1709
1710		if [ -f $TMPDIR/wsdiff.results ]; then
1711		    mv $TMPDIR/wsdiff.results $LLOG
1712		fi
1713
1714		if [ -f $TMPDIR/wsdiff-nd.results ]; then
1715			mv $TMPDIR/wsdiff-nd.results $LLOG
1716		fi
1717	fi
1718
1719	#
1720	# Now that we're about to send mail, it's time to check the noise
1721	# file.  In the event that an error occurs beyond this point, it will
1722	# be recorded in the nightly.log file, but nowhere else.  This would
1723	# include only errors that cause the copying of the noise log to fail
1724	# or the mail itself not to be sent.
1725	#
1726
1727	exec >>$LOGFILE 2>&1
1728	if [ -s $build_noise_file ]; then
1729	    	echo "\n==== Nightly build noise ====\n" |
1730		    tee -a $LOGFILE >>$mail_msg_file
1731		cat $build_noise_file >>$LOGFILE
1732		cat $build_noise_file >>$mail_msg_file
1733		echo | tee -a $LOGFILE >>$mail_msg_file
1734	fi
1735	rm -f $build_noise_file
1736
1737	case "$build_ok" in
1738		y)
1739			state=Completed
1740			;;
1741		i)
1742			state=Interrupted
1743			;;
1744		*)
1745	    		state=Failed
1746			;;
1747	esac
1748	NIGHTLY_STATUS=$state
1749	export NIGHTLY_STATUS
1750
1751	run_hook POST_NIGHTLY $state
1752	run_hook SYS_POST_NIGHTLY $state
1753
1754	cat $build_time_file $build_environ_file $mail_msg_file \
1755	    > ${LLOG}/mail_msg
1756	if [ "$m_FLAG" = "y" ]; then
1757	    	cat ${LLOG}/mail_msg | /usr/bin/mailx -s \
1758	"Nightly ${MACH} Build of `basename ${CODEMGR_WS}` ${state}." \
1759			${MAILTO}
1760	fi
1761
1762	if [ "$u_FLAG" = "y" -a "$build_ok" = "y" ]; then
1763	    	staffer cp ${LLOG}/mail_msg $PARENT_WS/usr/src/mail_msg-${MACH}
1764		staffer cp $LOGFILE $PARENT_WS/usr/src/nightly-${MACH}.log
1765	fi
1766
1767	mv $LOGFILE $LLOG
1768}
1769
1770#
1771#	Remove the locks and temporary files on any exit
1772#
1773cleanup() {
1774    	logshuffle
1775
1776	[ -z "$lockfile" ] || staffer rm -f $lockfile
1777	[ -z "$atloglockfile" ] || rm -f $atloglockfile
1778	[ -z "$ulockfile" ] || staffer rm -f $ulockfile
1779	[ -z "$Ulockfile" ] || rm -f $Ulockfile
1780
1781	set -- $newdirlist
1782	while [ $# -gt 0 ]; do
1783		ISUSER=$1 staffer rmdir $2
1784		shift; shift
1785	done
1786	rm -rf $TMPDIR
1787}
1788
1789cleanup_signal() {
1790    	build_ok=i
1791	# this will trigger cleanup(), above.
1792	exit 1
1793}
1794
1795trap cleanup 0
1796trap cleanup_signal 1 2 3 15
1797
1798#
1799# Generic lock file processing -- make sure that the lock file doesn't
1800# exist.  If it does, it should name the build host and PID.  If it
1801# doesn't, then make sure we can create it.  Clean up locks that are
1802# known to be stale (assumes host name is unique among build systems
1803# for the workspace).
1804#
1805create_lock() {
1806	lockf=$1
1807	lockvar=$2
1808
1809	ldir=`dirname $lockf`
1810	[ -d $ldir ] || newdir $ldir || exit 1
1811	eval $lockvar=$lockf
1812
1813	while ! staffer ln -s $hostname.$STAFFER.$$ $lockf 2> /dev/null; do
1814		basews=`basename $CODEMGR_WS`
1815		ls -l $lockf | nawk '{print $NF}' | IFS=. read host user pid
1816		if [ "$host" != "$hostname" ]; then
1817			echo "$MACH build of $basews apparently" \
1818			    "already started by $user on $host as $pid."
1819			exit 1
1820		elif kill -s 0 $pid 2>/dev/null; then
1821			echo "$MACH build of $basews already started" \
1822			    "by $user as $pid."
1823			exit 1
1824		else
1825			# stale lock; clear it out and try again
1826			rm -f $lockf
1827		fi
1828	done
1829}
1830
1831#
1832# Return the list of interesting proto areas, depending on the current
1833# options.
1834#
1835allprotos() {
1836	roots="$ROOT"
1837	if [ $O_FLAG = y ]; then
1838		# OpenSolaris deliveries require separate proto areas.
1839		[ $D_FLAG = y ] && roots="$roots $ROOT-open"
1840		[ $F_FLAG = n ] && roots="$roots $ROOT-open-nd"
1841	fi
1842	if [[ $D_FLAG = y && $F_FLAG = n ]]; then
1843		[ $MULTI_PROTO = yes ] && roots="$roots $ROOT-nd"
1844	fi
1845
1846	echo $roots
1847}
1848
1849# Ensure no other instance of this script is running on this host.
1850# LOCKNAME can be set in <env_file>, and is by default, but is not
1851# required due to the use of $ATLOG below.
1852if [ -n "$LOCKNAME" ]; then
1853	create_lock /tmp/$LOCKNAME "lockfile"
1854fi
1855#
1856# Create from one, two, or three other locks:
1857#	$ATLOG/nightly.lock
1858#		- protects against multiple builds in same workspace
1859#	$PARENT_WS/usr/src/nightly.$MACH.lock
1860#		- protects against multiple 'u' copy-backs
1861#	$NIGHTLY_PARENT_ROOT/nightly.lock
1862#		- protects against multiple 'U' copy-backs
1863#
1864# Overriding ISUSER to 1 causes the lock to be created as root if the
1865# script is run as root.  The default is to create it as $STAFFER.
1866ISUSER=1 create_lock $ATLOG/nightly.lock "atloglockfile"
1867if [ "$u_FLAG" = "y" ]; then
1868	create_lock $PARENT_WS/usr/src/nightly.$MACH.lock "ulockfile"
1869fi
1870if [ "$U_FLAG" = "y" ]; then
1871	# NIGHTLY_PARENT_ROOT is written as root if script invoked as root.
1872	ISUSER=1 create_lock $NIGHTLY_PARENT_ROOT/nightly.lock "Ulockfile"
1873fi
1874
1875# Locks have been taken, so we're doing a build and we're committed to
1876# the directories we may have created so far.
1877newdirlist=
1878
1879#
1880# Create mail_msg_file
1881#
1882mail_msg_file="${TMPDIR}/mail_msg"
1883touch $mail_msg_file
1884build_time_file="${TMPDIR}/build_time"
1885build_environ_file="${TMPDIR}/build_environ"
1886touch $build_environ_file
1887#
1888#	Move old LOGFILE aside
1889#	ATLOG directory already made by 'create_lock' above
1890#
1891if [ -f $LOGFILE ]; then
1892	mv -f $LOGFILE ${LOGFILE}-
1893fi
1894#
1895#	Build OsNet source
1896#
1897START_DATE=`date`
1898SECONDS=0
1899echo "\n==== Nightly $maketype build started:   $START_DATE ====" \
1900    | tee -a $LOGFILE > $build_time_file
1901
1902echo "\nBuild project:  $build_project\nBuild taskid:   $build_taskid" | \
1903    tee -a $mail_msg_file >> $LOGFILE
1904
1905# make sure we log only to the nightly build file
1906build_noise_file="${TMPDIR}/build_noise"
1907exec </dev/null >$build_noise_file 2>&1
1908
1909run_hook SYS_PRE_NIGHTLY
1910run_hook PRE_NIGHTLY
1911
1912echo "\n==== list of environment variables ====\n" >> $LOGFILE
1913env >> $LOGFILE
1914
1915echo "\n==== Nightly argument issues ====\n" | tee -a $mail_msg_file >> $LOGFILE
1916
1917if [ "$P_FLAG" = "y" ]; then
1918	obsolete_build GPROF | tee -a $mail_msg_file >> $LOGFILE
1919fi
1920
1921if [ "$T_FLAG" = "y" ]; then
1922	obsolete_build TRACE | tee -a $mail_msg_file >> $LOGFILE
1923fi
1924
1925if is_source_build; then
1926	if [ "$i_FLAG" = "y" -o "$i_CMD_LINE_FLAG" = "y" ]; then
1927		echo "WARNING: the -S flags do not support incremental" \
1928		    "builds; forcing clobber\n" | tee -a $mail_msg_file >> $LOGFILE
1929		i_FLAG=n
1930		i_CMD_LINE_FLAG=n
1931	fi
1932	if [ "$N_FLAG" = "n" ]; then
1933		echo "WARNING: the -S flags do not support protocmp;" \
1934		    "protocmp disabled\n" | \
1935		    tee -a $mail_msg_file >> $LOGFILE
1936		N_FLAG=y
1937	fi
1938	if [ "$l_FLAG" = "y" ]; then
1939		echo "WARNING: the -S flags do not support lint;" \
1940		    "lint disabled\n" | tee -a $mail_msg_file >> $LOGFILE
1941		l_FLAG=n
1942	fi
1943	if [ "$C_FLAG" = "y" ]; then
1944		echo "WARNING: the -S flags do not support cstyle;" \
1945		    "cstyle check disabled\n" | tee -a $mail_msg_file >> $LOGFILE
1946		C_FLAG=n
1947	fi
1948else
1949	if [ "$N_FLAG" = "y" ]; then
1950		if [ "$p_FLAG" = "y" ]; then
1951			cat <<EOF | tee -a $mail_msg_file >> $LOGFILE
1952WARNING: the p option (create packages) is set, but so is the N option (do
1953         not run protocmp); this is dangerous; you should unset the N option
1954EOF
1955		else
1956			cat <<EOF | tee -a $mail_msg_file >> $LOGFILE
1957Warning: the N option (do not run protocmp) is set; it probably shouldn't be
1958EOF
1959		fi
1960		echo "" | tee -a $mail_msg_file >> $LOGFILE
1961	fi
1962fi
1963
1964if [ "$O_FLAG" = "y" -a "$a_FLAG" = "n" ]; then
1965	echo "WARNING: OpenSolaris deliveries (-O) require archives;" \
1966	    "enabling the -a flag." | tee -a $mail_msg_file >> $LOGFILE
1967	a_FLAG=y
1968fi
1969
1970if [ "$a_FLAG" = "y" -a "$D_FLAG" = "n" -a "$F_FLAG" = "y" ]; then
1971	echo "WARNING: Neither DEBUG nor non-DEBUG build requested, but the" \
1972	    "'a' option was set." | tee -a $mail_msg_file >> $LOGFILE
1973fi
1974
1975if [ "$D_FLAG" = "n" -a "$l_FLAG" = "y" ]; then
1976	#
1977	# In the past we just complained but went ahead with the lint
1978	# pass, even though the proto area was built non-debug.  It's
1979	# unlikely that non-debug headers will make a difference, but
1980	# rather than assuming it's a safe combination, force the user
1981	# to specify a debug build.
1982	#
1983	echo "WARNING: DEBUG build not requested; disabling lint.\n" \
1984	    | tee -a $mail_msg_file >> $LOGFILE
1985	l_FLAG=n
1986fi
1987
1988if [ "$f_FLAG" = "y" ]; then
1989	if [ "$i_FLAG" = "y" ]; then
1990		echo "WARNING: the -f flag cannot be used during incremental" \
1991		    "builds; ignoring -f\n" | tee -a $mail_msg_file >> $LOGFILE
1992		f_FLAG=n
1993	fi
1994	if [ "$p_FLAG" != "y" -o "$l_FLAG" != "y" ]; then
1995		echo "WARNING: the -f flag requires -l and -p; ignoring -f\n" | \
1996		    tee -a $mail_msg_file >> $LOGFILE
1997		f_FLAG=n
1998	fi
1999fi
2000
2001if [ "$w_FLAG" = "y" -a ! -d $ROOT ]; then
2002	echo "WARNING: -w specified, but $ROOT does not exist;" \
2003	    "ignoring -w\n" | tee -a $mail_msg_file >> $LOGFILE
2004	w_FLAG=n
2005fi
2006
2007if [ "$t_FLAG" = "n" ]; then
2008	#
2009	# We're not doing a tools build, so make sure elfsign(1) is
2010	# new enough to safely sign non-crypto binaries.  We test
2011	# debugging output from elfsign to detect the old version.
2012	#
2013	newelfsigntest=`SUNW_CRYPTO_DEBUG=stderr /usr/bin/elfsign verify \
2014	    -e /usr/lib/security/pkcs11_softtoken.so.1 2>&1 \
2015	    | egrep algorithmOID`
2016	if [ -z "$newelfsigntest" ]; then
2017		echo "WARNING: /usr/bin/elfsign out of date;" \
2018		    "will only sign crypto modules\n" | \
2019		    tee -a $mail_msg_file >> $LOGFILE
2020		export ELFSIGN_OBJECT=true
2021	elif [ "$VERIFY_ELFSIGN" = "y" ]; then
2022		echo "WARNING: VERIFY_ELFSIGN=y requires" \
2023		    "the -t flag; ignoring VERIFY_ELFSIGN\n" | \
2024		    tee -a $mail_msg_file >> $LOGFILE
2025	fi
2026fi
2027
2028[ "$O_FLAG" = y ] && MULTI_PROTO=yes
2029
2030case $MULTI_PROTO in
2031yes|no)	;;
2032*)
2033	echo "WARNING: MULTI_PROTO is \"$MULTI_PROTO\"; " \
2034	    "should be \"yes\" or \"no\"." | tee -a $mail_msg_file >> $LOGFILE
2035	echo "Setting MULTI_PROTO to \"no\".\n" | \
2036	    tee -a $mail_msg_file >> $LOGFILE
2037	export MULTI_PROTO=no
2038	;;
2039esac
2040
2041echo "\n==== Build version ====\n" | tee -a $mail_msg_file >> $LOGFILE
2042echo $VERSION | tee -a $mail_msg_file >> $LOGFILE
2043
2044# Save the current proto area if we're comparing against the last build
2045if [ "$w_FLAG" = "y" -a -d "$ROOT" ]; then
2046    if [ -d "$ROOT.prev" ]; then
2047	rm -rf $ROOT.prev
2048    fi
2049    mv $ROOT $ROOT.prev
2050fi
2051
2052# Same for non-DEBUG proto area
2053if [ "$w_FLAG" = "y" -a "$MULTI_PROTO" = yes -a -d "$ROOT-nd" ]; then
2054	if [ -d "$ROOT-nd.prev" ]; then
2055		rm -rf $ROOT-nd.prev
2056	fi
2057	mv $ROOT-nd $ROOT-nd.prev
2058fi
2059
2060# Echo the SCM types of $CODEMGR_WS and $BRINGOVER_WS
2061function wstypes {
2062	typeset parent_type child_type junk
2063
2064	CODEMGR_WS="$BRINGOVER_WS" "$WHICH_SCM" 2>/dev/null \
2065	    | read parent_type junk
2066	if [[ -z "$parent_type" || "$parent_type" == unknown ]]; then
2067		# Probe BRINGOVER_WS to determine its type
2068		if [[ $BRINGOVER_WS == svn*://* ]]; then
2069			parent_type="subversion"
2070		elif [[ $BRINGOVER_WS == file://* ]] &&
2071		    egrep -s "This is a Subversion repository" \
2072		    ${BRINGOVER_WS#file://}/README.txt 2> /dev/null; then
2073			parent_type="subversion"
2074		elif [[ $BRINGOVER_WS == ssh://* ]]; then
2075			parent_type="mercurial"
2076		elif svn info $BRINGOVER_WS > /dev/null 2>&1; then
2077			parent_type="subversion"
2078		elif [[ $BRINGOVER_WS == http://* ]] && \
2079		    http_get "$BRINGOVER_WS/?cmd=heads" | \
2080		    egrep -s "application/mercurial" 2> /dev/null; then
2081			parent_type="mercurial"
2082		else
2083			parent_type="none"
2084		fi
2085	fi
2086
2087	# Probe CODEMGR_WS to determine its type
2088	if [[ -d $CODEMGR_WS ]]; then
2089		$WHICH_SCM | read child_type junk || exit 1
2090	fi
2091
2092	# fold both unsupported and unrecognized results into "none"
2093	case "$parent_type" in
2094	none|subversion|teamware|mercurial)
2095		;;
2096	*)	parent_type=none
2097		;;
2098	esac
2099	case "$child_type" in
2100	none|subversion|teamware|mercurial)
2101		;;
2102	*)	child_type=none
2103		;;
2104	esac
2105
2106	echo $child_type $parent_type
2107}
2108
2109wstypes | read SCM_TYPE PARENT_SCM_TYPE
2110export SCM_TYPE PARENT_SCM_TYPE
2111
2112#
2113#	Decide whether to clobber
2114#
2115if [ "$i_FLAG" = "n" -a -d "$SRC" ]; then
2116	echo "\n==== Make clobber at `date` ====\n" >> $LOGFILE
2117
2118	cd $SRC
2119	# remove old clobber file
2120	rm -f $SRC/clobber.out
2121	rm -f $SRC/clobber-${MACH}.out
2122
2123	# Remove all .make.state* files, just in case we are restarting
2124	# the build after having interrupted a previous 'make clobber'.
2125	find . \( -name SCCS -o -name .hg -o -name .svn \
2126		-o -name 'interfaces.*' \) -prune \
2127		-o -name '.make.*' -print | xargs rm -f
2128
2129	$MAKE -ek clobber 2>&1 | tee -a $SRC/clobber-${MACH}.out >> $LOGFILE
2130	echo "\n==== Make clobber ERRORS ====\n" >> $mail_msg_file
2131	grep "$MAKE:" $SRC/clobber-${MACH}.out |
2132		egrep -v "Ignoring unknown host" \
2133		>> $mail_msg_file
2134
2135	if [[ "$t_FLAG" = "y" || "$O_FLAG" = "y" ]]; then
2136		echo "\n==== Make tools clobber at `date` ====\n" >> $LOGFILE
2137		cd ${TOOLS}
2138		rm -f ${TOOLS}/clobber-${MACH}.out
2139		$MAKE -ek clobber 2>&1 | \
2140			tee -a ${TOOLS}/clobber-${MACH}.out >> $LOGFILE
2141		echo "\n==== Make tools clobber ERRORS ====\n" \
2142			>> $mail_msg_file
2143		grep "$MAKE:" ${TOOLS}/clobber-${MACH}.out \
2144			>> $mail_msg_file
2145		rm -rf ${TOOLS_PROTO}
2146		mkdir -p ${TOOLS_PROTO}
2147	fi
2148
2149	rm -rf `allprotos`
2150
2151	# Get back to a clean workspace as much as possible to catch
2152	# problems that only occur on fresh workspaces.
2153	# Remove all .make.state* files, libraries, and .o's that may
2154	# have been omitted from clobber.  A couple of libraries are
2155	# under source code control, so leave them alone.
2156	# We should probably blow away temporary directories too.
2157	cd $SRC
2158	find $relsrcdirs \( -name SCCS -o -name .hg -o -name .svn \
2159	    -o -name 'interfaces.*' \) -prune -o \
2160	    \( -name '.make.*' -o -name 'lib*.a' -o -name 'lib*.so*' -o \
2161	       -name '*.o' \) -print | \
2162	    grep -v 'tools/ctf/dwarf/.*/libdwarf' | xargs rm -f
2163else
2164	echo "\n==== No clobber at `date` ====\n" >> $LOGFILE
2165fi
2166
2167type bringover_teamware > /dev/null 2>&1 || bringover_teamware() {
2168	# sleep on the parent workspace's lock
2169	while egrep -s write $BRINGOVER_WS/Codemgr_wsdata/locks
2170	do
2171		sleep 120
2172	done
2173
2174	if [[ -z $BRINGOVER ]]; then
2175		BRINGOVER=$TEAMWARE/bin/bringover
2176	fi
2177
2178	staffer $BRINGOVER -c "nightly update" -p $BRINGOVER_WS \
2179	    -w $CODEMGR_WS $BRINGOVER_FILES < /dev/null 2>&1 ||
2180		touch $TMPDIR/bringover_failed
2181
2182        staffer bringovercheck $CODEMGR_WS >$TMPDIR/bringovercheck.out 2>&1
2183	if [ -s $TMPDIR/bringovercheck.out ]; then
2184		echo "\n==== POST-BRINGOVER CLEANUP NOISE ====\n"
2185		cat $TMPDIR/bringovercheck.out
2186	fi
2187}
2188
2189type bringover_mercurial > /dev/null 2>&1 || bringover_mercurial() {
2190	typeset -x PATH=$PATH
2191
2192	# If the repository doesn't exist yet, then we want to populate it.
2193	if [[ ! -d $CODEMGR_WS/.hg ]]; then
2194		staffer hg init $CODEMGR_WS
2195	fi
2196
2197	#
2198	# If the user set CLOSED_BRINGOVER_WS and didn't set CLOSED_IS_PRESENT
2199	# to "no," then we'll want to initialise the closed repository
2200	#
2201	# We use $orig_closed_is_present instead of $CLOSED_IS_PRESENT,
2202	# because for newly-created source trees, the latter will be "no"
2203	# until after the bringover completes.
2204	#
2205	if [[ "$orig_closed_is_present" != "no" && \
2206	    -n "$CLOSED_BRINGOVER_WS" && \
2207	    ! -d $CODEMGR_WS/usr/closed/.hg ]]; then
2208		staffer mkdir -p $CODEMGR_WS/usr/closed
2209		staffer hg init $CODEMGR_WS/usr/closed
2210		export CLOSED_IS_PRESENT=yes
2211	fi
2212
2213	typeset -x HGMERGE="/bin/false"
2214
2215	#
2216	# If the user has changes, regardless of whether those changes are
2217	# committed, and regardless of whether those changes conflict, then
2218	# we'll attempt to merge them either implicitly (uncommitted) or
2219	# explicitly (committed).
2220	#
2221	# These are the messages we'll use to help clarify mercurial output
2222	# in those cases.
2223	#
2224	typeset mergefailmsg="\
2225***\n\
2226*** nightly was unable to automatically merge your changes.  You should\n\
2227*** redo the full merge manually, following the steps outlined by mercurial\n\
2228*** above, then restart nightly.\n\
2229***\n"
2230	typeset mergepassmsg="\
2231***\n\
2232*** nightly successfully merged your changes.  This means that your working\n\
2233*** directory has been updated, but those changes are not yet committed.\n\
2234*** After nightly completes, you should validate the results of the merge,\n\
2235*** then use hg commit manually.\n\
2236***\n"
2237
2238	#
2239	# For each repository in turn:
2240	#
2241	# 1. Do the pull.  If this fails, dump the output and bail out.
2242	#
2243	# 2. If the pull resulted in an extra head, do an explicit merge.
2244	#    If this fails, dump the output and bail out.
2245	#
2246	# Because we can't rely on Mercurial to exit with a failure code
2247	# when a merge fails (Mercurial issue #186), we must grep the
2248	# output of pull/merge to check for attempted and/or failed merges.
2249	#
2250	# 3. If a merge failed, set the message and fail the bringover.
2251	#
2252	# 4. Otherwise, if a merge succeeded, set the message
2253	#
2254	# 5. Dump the output, and any message from step 3 or 4.
2255	#
2256
2257	staffer hg --cwd $CODEMGR_WS pull -u $BRINGOVER_WS \
2258	    > $TMPDIR/pull_open.out 2>&1
2259	if (( $? != 0 )); then
2260		printf "%s: pull failed as follows:\n\n" "$CODEMGR_WS"
2261		cat $TMPDIR/pull_open.out
2262		if grep "^merging.*failed" $TMPDIR/pull_open.out > /dev/null 2>&1; then
2263			printf "$mergefailmsg"
2264		fi
2265		touch $TMPDIR/bringover_failed
2266		return
2267	fi
2268
2269	if grep "not updating" $TMPDIR/pull_open.out > /dev/null 2>&1; then
2270		staffer hg --cwd $CODEMGR_WS merge \
2271		    >> $TMPDIR/pull_open.out 2>&1
2272		if (( $? != 0 )); then
2273			printf "%s: merge failed as follows:\n\n" \
2274			    "$CODEMGR_WS"
2275			cat $TMPDIR/pull_open.out
2276			if grep "^merging.*failed" $TMPDIR/pull_open.out \
2277			    > /dev/null 2>&1; then
2278				printf "$mergefailmsg"
2279			fi
2280			touch $TMPDIR/bringover_failed
2281			return
2282		fi
2283	fi
2284
2285	printf "updated %s with the following results:\n" "$CODEMGR_WS"
2286	cat $TMPDIR/pull_open.out
2287	if grep "^merging" $TMPDIR/pull_open.out >/dev/null 2>&1; then
2288		printf "$mergepassmsg"
2289	fi
2290	printf "\n"
2291
2292	#
2293	# We only want to update usr/closed if it exists, and we haven't been
2294	# told not to via $CLOSED_IS_PRESENT, and we actually know where to
2295	# pull from ($CLOSED_BRINGOVER_WS).
2296	#
2297	if [[ $CLOSED_IS_PRESENT = yes && \
2298	    -d $CODEMGR_WS/usr/closed/.hg && \
2299	    -n $CLOSED_BRINGOVER_WS ]]; then
2300
2301		staffer hg --cwd $CODEMGR_WS/usr/closed pull -u \
2302			$CLOSED_BRINGOVER_WS > $TMPDIR/pull_closed.out 2>&1
2303		if (( $? != 0 )); then
2304			printf "closed pull failed as follows:\n\n"
2305			cat $TMPDIR/pull_closed.out
2306			if grep "^merging.*failed" $TMPDIR/pull_closed.out \
2307			    > /dev/null 2>&1; then
2308				printf "$mergefailmsg"
2309			fi
2310			touch $TMPDIR/bringover_failed
2311			return
2312		fi
2313
2314		if grep "not updating" $TMPDIR/pull_closed.out > /dev/null 2>&1; then
2315			staffer hg --cwd $CODEMGR_WS/usr/closed merge \
2316			    >> $TMPDIR/pull_closed.out 2>&1
2317			if (( $? != 0 )); then
2318				printf "closed merge failed as follows:\n\n"
2319				cat $TMPDIR/pull_closed.out
2320				if grep "^merging.*failed" $TMPDIR/pull_closed.out > /dev/null 2>&1; then
2321					printf "$mergefailmsg"
2322				fi
2323				touch $TMPDIR/bringover_failed
2324				return
2325			fi
2326		fi
2327
2328		printf "updated %s with the following results:\n" \
2329		    "$CODEMGR_WS/usr/closed"
2330		cat $TMPDIR/pull_closed.out
2331		if grep "^merging" $TMPDIR/pull_closed.out > /dev/null 2>&1; then
2332			printf "$mergepassmsg"
2333		fi
2334	fi
2335}
2336
2337type bringover_subversion > /dev/null 2>&1 || bringover_subversion() {
2338	typeset -x PATH=$PATH
2339
2340	if [[ ! -d $CODEMGR_WS/.svn ]]; then
2341		staffer svn checkout $BRINGOVER_WS $CODEMGR_WS ||
2342			touch $TMPDIR/bringover_failed
2343	else
2344		typeset root
2345		root=$(staffer svn info $CODEMGR_WS |
2346			nawk '/^Repository Root:/ {print $NF}')
2347		if [[ $root != $BRINGOVER_WS ]]; then
2348			# We fail here because there's no way to update
2349			# from a named repo.
2350			cat <<-EOF
2351			\$BRINGOVER_WS doesn't match repository root:
2352			  \$BRINGOVER_WS:  $BRINGOVER_WS
2353			  Repository root: $root
2354			EOF
2355			touch $TMPDIR/bringover_failed
2356		else
2357			# If a conflict happens, svn still exits 0.
2358			staffer svn update $CODEMGR_WS | tee $TMPDIR/pull.out ||
2359				touch $TMPDIR/bringover_failed
2360			if grep "^C" $TMPDIR/pull.out > /dev/null 2>&1; then
2361				touch $TMPDIR/bringover_failed
2362			fi
2363		fi
2364	fi
2365}
2366
2367type bringover_none > /dev/null 2>&1 || bringover_none() {
2368	echo "Couldn't figure out what kind of SCM to use for $BRINGOVER_WS."
2369	touch $TMPDIR/bringover_failed
2370}
2371
2372# Parse the URL.
2373# The other way to deal with empty components is to echo a string that can
2374# be eval'ed by the caller to associate values (possibly empty) with
2375# variables.  In that case, passing in a printf string would let the caller
2376# choose the variable names.
2377parse_url() {
2378	typeset url method host port path
2379
2380	url=$1
2381	method=${url%%://*}
2382	host=${url#$method://}
2383	path=${host#*/}
2384	host=${host%%/*}
2385	if [[ $host == *:* ]]; then
2386		port=${host#*:}
2387		host=${host%:*}
2388	fi
2389
2390	# method can never be empty.  host can only be empty if method is
2391	# file, and that implies it's localhost.  path can default to / if
2392	# it's otherwise empty, leaving port as the only component without
2393	# a default, so it has to go last.
2394	echo $method ${host:-localhost} ${path:-/} $port
2395}
2396
2397http_get() {
2398	typeset url method host port path
2399
2400	url=$1
2401
2402	if [[ -n $http_proxy ]]; then
2403		parse_url $http_proxy | read method host path port
2404		echo "GET $url HTTP/1.0\r\n" |
2405			mconnect -p ${port:-8080} $host
2406	else
2407		parse_url $url | read method host path port
2408		echo "GET $path HTTP/1.0\r\n" |
2409			mconnect -p ${port:-80} $host
2410	fi
2411}
2412
2413#
2414#	Decide whether to bringover to the codemgr workspace
2415#
2416if [ "$n_FLAG" = "n" ]; then
2417
2418	if [[ $SCM_TYPE != none && $SCM_TYPE != $PARENT_SCM_TYPE ]]; then
2419		echo "cannot bringover from $PARENT_SCM_TYPE to $SCM_TYPE, " \
2420		    "quitting at `date`." | tee -a $mail_msg_file >> $LOGFILE
2421		exit 1
2422	fi
2423
2424	run_hook PRE_BRINGOVER
2425
2426	echo "\n==== bringover to $CODEMGR_WS at `date` ====\n" >> $LOGFILE
2427	echo "\n==== BRINGOVER LOG ====\n" >> $mail_msg_file
2428
2429	eval "bringover_${PARENT_SCM_TYPE}" 2>&1 |
2430		tee -a $mail_msg_file >> $LOGFILE
2431
2432	if [ -f $TMPDIR/bringover_failed ]; then
2433		rm -f $TMPDIR/bringover_failed
2434		build_ok=n
2435		echo "trouble with bringover, quitting at `date`." |
2436			tee -a $mail_msg_file >> $LOGFILE
2437		exit 1
2438	fi
2439
2440	#
2441	# It's possible that we used the bringover above to create
2442	# $CODEMGR_WS.  If so, then SCM_TYPE was previously "none,"
2443	# but should now be the same as $BRINGOVER_WS.
2444	#
2445	[[ $SCM_TYPE = none ]] && SCM_TYPE=$PARENT_SCM_TYPE
2446
2447	run_hook POST_BRINGOVER
2448
2449	#
2450	# Possible transition from pre-split workspace to split
2451	# workspace.  See if the bringover changed anything.
2452	#
2453	CLOSED_IS_PRESENT="$orig_closed_is_present"
2454	check_closed_tree
2455else
2456	echo "\n==== No bringover to $CODEMGR_WS ====\n" >> $LOGFILE
2457fi
2458
2459echo "\n==== Build environment ====\n" | tee -a $build_environ_file >> $LOGFILE
2460
2461# System
2462whence uname | tee -a $build_environ_file >> $LOGFILE
2463uname -a 2>&1 | tee -a $build_environ_file >> $LOGFILE
2464echo | tee -a $build_environ_file >> $LOGFILE
2465
2466# nightly
2467echo "$0 $@" | tee -a $build_environ_file >> $LOGFILE
2468if [[ $nightly_path = "/opt/onbld/bin/nightly" ]] &&
2469    pkginfo SUNWonbld > /dev/null 2>&1 ; then
2470	pkginfo -l SUNWonbld | egrep "PKGINST:|VERSION:|PSTAMP:"
2471else
2472	echo "$nightly_ls"
2473fi | tee -a $build_environ_file >> $LOGFILE
2474echo | tee -a $build_environ_file >> $LOGFILE
2475
2476# make
2477whence $MAKE | tee -a $build_environ_file >> $LOGFILE
2478$MAKE -v | tee -a $build_environ_file >> $LOGFILE
2479echo "number of concurrent jobs = $DMAKE_MAX_JOBS" |
2480    tee -a $build_environ_file >> $LOGFILE
2481
2482#
2483# Report the compiler versions.
2484#
2485
2486if [[ ! -f $SRC/Makefile ]]; then
2487	build_ok=n
2488	echo "\nUnable to find \"Makefile\" in $SRC." | \
2489	    tee -a $build_environ_file >> $LOGFILE
2490	exit 1
2491fi
2492
2493( cd $SRC
2494  for target in cc-version cc64-version java-version; do
2495	echo
2496	#
2497	# Put statefile somewhere we know we can write to rather than trip
2498	# over a read-only $srcroot.
2499	#
2500	rm -f $TMPDIR/make-state
2501	export SRC
2502	if $MAKE -K $TMPDIR/make-state -e $target 2>/dev/null; then
2503		continue
2504	fi
2505	touch $TMPDIR/nocompiler
2506  done
2507  echo
2508) | tee -a $build_environ_file >> $LOGFILE
2509
2510if [ -f $TMPDIR/nocompiler ]; then
2511	rm -f $TMPDIR/nocompiler
2512	build_ok=n
2513	echo "Aborting due to missing compiler." |
2514		tee -a $build_environ_file >> $LOGFILE
2515	exit 1
2516fi
2517
2518# as
2519whence as | tee -a $build_environ_file >> $LOGFILE
2520as -V 2>&1 | head -1 | tee -a $build_environ_file >> $LOGFILE
2521echo | tee -a $build_environ_file >> $LOGFILE
2522
2523# Check that we're running a capable link-editor
2524whence ld | tee -a $build_environ_file >> $LOGFILE
2525LDVER=`ld -V 2>&1`
2526echo $LDVER | tee -a $build_environ_file >> $LOGFILE
2527LDVER=`echo $LDVER | sed -e "s/.*-1\.//" -e "s/:.*//"`
2528if [ `expr $LDVER \< 422` -eq 1 ]; then
2529	echo "The link-editor needs to be at version 422 or higher to build" | \
2530	    tee -a $build_environ_file >> $LOGFILE
2531	echo "the latest stuff.  Hope your build works." | \
2532	    tee -a $build_environ_file >> $LOGFILE
2533fi
2534
2535#
2536# Build and use the workspace's tools if requested
2537#
2538if [[ "$t_FLAG" = "y" || "$O_FLAG" = y ]]; then
2539	set_non_debug_build_flags
2540
2541	build_tools ${TOOLS_PROTO}
2542
2543	if [[ $? -ne 0 && "$t_FLAG" = y ]]; then
2544		use_tools $TOOLS_PROTO
2545		export ONBLD_TOOLS=${ONBLD_TOOLS:=${TOOLS_PROTO}/opt/onbld}
2546	fi
2547fi
2548
2549#
2550# copy ihv proto area in addition to the build itself
2551#
2552if [ "$X_FLAG" = "y" ]; then
2553	copy_ihv_proto
2554fi
2555
2556if [ "$i_FLAG" = "y" -a "$SH_FLAG" = "y" ]; then
2557	echo "\n==== NOT Building base OS-Net source ====\n" | \
2558	    tee -a $LOGFILE >> $mail_msg_file
2559else
2560	# timestamp the start of the normal build; the findunref tool uses it.
2561	touch $SRC/.build.tstamp
2562
2563	normal_build
2564fi
2565
2566#
2567# Generate the THIRDPARTYLICENSE files if needed.  This is done before
2568# findunref to help identify license files that need to be added to
2569# the list.
2570#
2571if [ "$O_FLAG" = y -a "$build_ok" = y ]; then
2572	echo "\n==== Generating THIRDPARTYLICENSE files ====\n" | \
2573	    tee -a $mail_msg_file >> $LOGFILE
2574
2575	mktpl usr/src/tools/opensolaris/license-list >>$LOGFILE 2>&1
2576	if (( $? != 0 )) ; then
2577		echo "Couldn't create THIRDPARTYLICENSE files" |
2578		    tee -a $mail_msg_file >> $LOGFILE
2579	fi
2580fi
2581
2582#
2583# If OpenSolaris deliverables were requested, do the open-only build
2584# now, so that it happens at roughly the same point as the source
2585# product builds.  This lets us take advantage of checks that come
2586# later (e.g., the core file check).
2587#
2588if [ "$O_FLAG" = y -a "$build_ok" = y ]; then
2589	#
2590	# Generate skeleton (minimal) closed binaries for open-only
2591	# build.  There's no need to distinguish debug from non-debug
2592	# binaries, but it simplifies file management to have separate
2593	# trees.
2594	#
2595
2596	echo "\n==== Generating skeleton closed binaries for" \
2597	    "open-only build ====\n" | \
2598	    tee -a $LOGFILE >> $mail_msg_file
2599
2600	rm -rf $CODEMGR_WS/closed.skel
2601	if [ "$D_FLAG" = y ]; then
2602		mkclosed $MACH $ROOT $CODEMGR_WS/closed.skel/root_$MACH \
2603		    >>$LOGFILE 2>&1
2604		if (( $? != 0 )) ; then
2605			echo "Couldn't create skeleton DEBUG closed binaries." |
2606			    tee -a $mail_msg_file >> $LOGFILE
2607		fi
2608	fi
2609	if [ "$F_FLAG" = n ]; then
2610		mkclosed $MACH $ROOT-nd $CODEMGR_WS/closed.skel/root_$MACH-nd \
2611		    >>$LOGFILE 2>&1
2612		if (( $? != 0 )) ; then
2613			echo "Couldn't create skeleton non-DEBUG closed binaries." |
2614			    tee -a $mail_msg_file >> $LOGFILE
2615		fi
2616	fi
2617
2618	ORIG_CLOSED_IS_PRESENT=$CLOSED_IS_PRESENT
2619	export CLOSED_IS_PRESENT=no
2620
2621	ORIG_ON_CLOSED_BINS="$ON_CLOSED_BINS"
2622	export ON_CLOSED_BINS=$CODEMGR_WS/closed.skel
2623
2624	normal_build -O
2625
2626	ON_CLOSED_BINS=$ORIG_ON_CLOSED_BINS
2627	CLOSED_IS_PRESENT=$ORIG_CLOSED_IS_PRESENT
2628fi
2629
2630ORIG_SRC=$SRC
2631BINARCHIVE=${CODEMGR_WS}/bin-${MACH}.cpio.Z
2632
2633if [ "$SE_FLAG" = "y" -o "$SD_FLAG" = "y" -o "$SH_FLAG" = "y" ]; then
2634	save_binaries
2635fi
2636
2637
2638# EXPORT_SRC comes after CRYPT_SRC since a domestic build will need
2639# $SRC pointing to the export_source usr/src.
2640
2641if [ "$SE_FLAG" = "y" -o "$SD_FLAG" = "y" -o "$SH_FLAG" = "y" ]; then
2642	if [ "$SD_FLAG" = "y" -a $build_ok = y ]; then
2643	    set_up_source_build ${CODEMGR_WS} ${CRYPT_SRC} CRYPT_SRC
2644	fi
2645
2646	if [ $build_ok = y ]; then
2647	    set_up_source_build ${CODEMGR_WS} ${EXPORT_SRC} EXPORT_SRC
2648	fi
2649fi
2650
2651if [ "$SD_FLAG" = "y" -a $build_ok = y ]; then
2652	# drop the crypt files in place.
2653	cd ${EXPORT_SRC}
2654	echo "\nextracting crypt_files.cpio.Z onto export_source.\n" \
2655	    >> ${LOGFILE}
2656	zcat ${CODEMGR_WS}/crypt_files.cpio.Z | \
2657	    cpio -idmucvB 2>/dev/null >> ${LOGFILE}
2658	if [ "$?" = "0" ]; then
2659		echo "\n==== DOMESTIC extraction succeeded ====\n" \
2660		    >> $mail_msg_file
2661	else
2662		echo "\n==== DOMESTIC extraction failed ====\n" \
2663		    >> $mail_msg_file
2664	fi
2665
2666fi
2667
2668if [ "$SO_FLAG" = "y" -a $build_ok = y ]; then
2669	#
2670	# Copy the open sources into their own tree, set up the closed
2671	# binaries, and set up the environment.  The build looks for
2672	# the closed binaries in a location that depends on whether
2673	# it's a DEBUG build, so we might need to make two copies.
2674	#
2675	# If copy_source fails, it will have already generated an
2676	# error message and set build_ok=n, so we don't need to worry
2677	# about that here.
2678	#
2679	copy_source $CODEMGR_WS $OPEN_SRCDIR OPEN_SOURCE usr/src
2680fi
2681
2682if [ "$SO_FLAG" = "y" -a $build_ok = y ]; then
2683	SRC=$OPEN_SRCDIR/usr/src
2684
2685	# Try not to clobber any user-provided closed binaries.
2686	export ON_CLOSED_BINS=$CODEMGR_WS/closed$$
2687
2688	echo "\n==== Copying skeleton closed binaries to" \
2689	    "$ON_CLOSED_BINS ====\n" | \
2690	    tee -a $mail_msg_file >> $LOGFILE
2691
2692	if [ "$D_FLAG" = y ]; then
2693		mkclosed $MACH $ROOT $ON_CLOSED_BINS/root_$MACH >>$LOGFILE 2>&1
2694		if (( $? != 0 )) ; then
2695			build_ok=n
2696			echo "Couldn't create DEBUG closed binaries." |
2697			    tee -a $mail_msg_file >> $LOGFILE
2698		fi
2699	fi
2700	if [ "$F_FLAG" = n ]; then
2701		root=$ROOT
2702		[ "$MULTI_PROTO" = yes ] && root=$ROOT-nd
2703		mkclosed $MACH $root $ON_CLOSED_BINS/root_$MACH-nd \
2704		    >>$LOGFILE 2>&1
2705		if (( $? != 0 )) ; then
2706			build_ok=n
2707			echo "Couldn't create non-DEBUG closed binaries." |
2708			    tee -a $mail_msg_file >> $LOGFILE
2709		fi
2710	fi
2711
2712	export CLOSED_IS_PRESENT=no
2713fi
2714
2715if is_source_build && [ $build_ok = y ] ; then
2716	# remove proto area(s) here, since we don't clobber
2717	rm -rf `allprotos`
2718	if [ "$t_FLAG" = "y" ]; then
2719		set_non_debug_build_flags
2720		ORIG_TOOLS=$TOOLS
2721		#
2722		# SRC was set earlier to point to the source build
2723		# source tree (e.g., $EXPORT_SRC).
2724		#
2725		TOOLS=${SRC}/tools
2726		build_tools ${SRC}/tools/proto
2727		TOOLS=$ORIG_TOOLS
2728	fi
2729
2730	export EXPORT_RELEASE_BUILD ; EXPORT_RELEASE_BUILD=#
2731	normal_build
2732fi
2733
2734if [[ "$SO_FLAG" = "y" && "$build_ok" = "y" ]]; then
2735	rm -rf $ON_CLOSED_BINS
2736fi
2737
2738#
2739# There are several checks that need to look at the proto area, but
2740# they only need to look at one, and they don't care whether it's
2741# DEBUG or non-DEBUG.
2742#
2743if [[ "$MULTI_PROTO" = yes && "$D_FLAG" = n ]]; then
2744	checkroot=$ROOT-nd
2745else
2746	checkroot=$ROOT
2747fi
2748
2749if [ "$build_ok" = "y" ]; then
2750	echo "\n==== Creating protolist system file at `date` ====" \
2751		>> $LOGFILE
2752	protolist $checkroot > $ATLOG/proto_list_${MACH}
2753	echo "==== protolist system file created at `date` ====\n" \
2754		>> $LOGFILE
2755
2756	if [ "$N_FLAG" != "y" ]; then
2757		echo "\n==== Impact on packages ====\n" >> $mail_msg_file
2758
2759		# If there is a reference proto list, compare the build's proto
2760		# list with the reference to see changes in proto areas.
2761		# Use the current exception list.
2762		exc=etc/exception_list_$MACH
2763		if [ -f $SRC/pkgdefs/$exc ]; then
2764			ELIST="-e $SRC/pkgdefs/$exc"
2765		fi
2766		if [ "$X_FLAG" = "y" -a -f $IA32_IHV_WS/usr/src/pkgdefs/$exc ]; then
2767			ELIST="$ELIST -e $IA32_IHV_WS/usr/src/pkgdefs/$exc"
2768		fi
2769
2770		if [ -f "$REF_PROTO_LIST" ]; then
2771			# For builds that copy the IHV proto area (-X), add the
2772			# IHV proto list to the reference list if the reference
2773			# was built without -X.
2774			#
2775			# For builds that don't copy the IHV proto area, add the
2776			# IHV proto list to the build's proto list if the
2777			# reference was built with -X.
2778			#
2779			# Use the presence of the first file entry of the cached
2780			# IHV proto list in the reference list to determine
2781			# whether it was build with -X or not.
2782			IHV_REF_PROTO_LIST=$SRC/pkgdefs/etc/proto_list_ihv_$MACH
2783			grepfor=$(nawk '$1 == "f" { print $2; exit }' \
2784				$IHV_REF_PROTO_LIST 2> /dev/null)
2785			if [ $? = 0 -a -n "$grepfor" ]; then
2786				if [ "$X_FLAG" = "y" ]; then
2787					grep -w "$grepfor" \
2788						$REF_PROTO_LIST > /dev/null
2789					if [ ! "$?" = "0" ]; then
2790						REF_IHV_PROTO="-d $IHV_REF_PROTO_LIST"
2791					fi
2792				else
2793					grep -w "$grepfor" \
2794						$REF_PROTO_LIST > /dev/null
2795					if [ "$?" = "0" ]; then
2796						IHV_PROTO_LIST="$IHV_REF_PROTO_LIST"
2797					fi
2798				fi
2799			fi
2800
2801			$PROTOCMPTERSE \
2802			  "Files in yesterday's proto area, but not today's:" \
2803			  "Files in today's proto area, but not yesterday's:" \
2804			  "Files that changed between yesterday and today:" \
2805			  ${ELIST} \
2806			  -d $REF_PROTO_LIST \
2807			  $REF_IHV_PROTO \
2808			  $ATLOG/proto_list_${MACH} \
2809			  $IHV_PROTO_LIST \
2810				>> $mail_msg_file
2811		fi
2812		# Compare the build's proto list with current package
2813		# definitions to audit the quality of package definitions
2814		# and makefile install targets. Use the current exception list.
2815		PKGDEFS_LIST=""
2816		for d in $abssrcdirs; do
2817			if [ -d $d/pkgdefs ]; then
2818				PKGDEFS_LIST="$PKGDEFS_LIST -d $d/pkgdefs"
2819			fi
2820		done
2821		if [ "$X_FLAG" = "y" -a -d $IA32_IHV_WS/usr/src/pkgdefs ]; then
2822			PKGDEFS_LIST="$PKGDEFS_LIST -d $IA32_IHV_WS/usr/src/pkgdefs"
2823		fi
2824
2825		$PROTOCMPTERSE \
2826		    "Files missing from the proto area:" \
2827		    "Files missing from packages:" \
2828		    "Inconsistencies between pkgdefs and proto area:" \
2829		    ${ELIST} \
2830		    ${PKGDEFS_LIST} \
2831		    $ATLOG/proto_list_${MACH} \
2832		    >> $mail_msg_file
2833	fi
2834fi
2835
2836if [ "$u_FLAG" = "y"  -a "$build_ok" = "y" ]; then
2837	staffer cp $ATLOG/proto_list_${MACH} \
2838		$PARENT_WS/usr/src/proto_list_${MACH}
2839fi
2840
2841# Update parent proto area if necessary. This is done now
2842# so that the proto area has either DEBUG or non-DEBUG kernels.
2843# Note that this clears out the lock file, so we can dispense with
2844# the variable now.
2845if [ "$U_FLAG" = "y" -a "$build_ok" = "y" ]; then
2846	echo "\n==== Copying proto area to $NIGHTLY_PARENT_ROOT ====\n" | \
2847	    tee -a $LOGFILE >> $mail_msg_file
2848	# The rm -rf command below produces predictable errors if
2849	# nightly is invoked from the parent's $ROOT/opt/onbld/bin,
2850	# and that directory is accessed via NFS.  This is because
2851	# deleted-but-still-open files don't actually disappear as
2852	# expected, but rather turn into .nfsXXXX junk files, leaving
2853	# the directory non-empty.  Since this is a not-unusual usage
2854	# pattern, and we still want to catch other errors here, we
2855	# take the unusal step of moving aside 'nightly' from that
2856	# directory (if we're using it).
2857	mypath=${nightly_path##*/root_$MACH/}
2858	if [ "$mypath" = $nightly_path ]; then
2859		mypath=opt/onbld/bin/${nightly_path##*/}
2860	fi
2861	if [ $nightly_path -ef $PARENT_WS/proto/root_$MACH/$mypath ]; then
2862		mv -f $nightly_path $PARENT_WS/proto/root_$MACH
2863	fi
2864	rm -rf $PARENT_WS/proto/root_$MACH/*
2865	unset Ulockfile
2866	mkdir -p $NIGHTLY_PARENT_ROOT
2867	if [[ "$MULTI_PROTO" = no || "$D_FLAG" = y ]]; then
2868		cd $ROOT
2869		( tar cf - . |
2870		    ( cd $NIGHTLY_PARENT_ROOT;  umask 0; tar xpf - ) ) 2>&1 |
2871		    tee -a $mail_msg_file >> $LOGFILE
2872	fi
2873	if [[ "$MULTI_PROTO" = yes && "$F_FLAG" = n ]]; then
2874		mkdir -p $NIGHTLY_PARENT_ROOT-nd
2875		cd $ROOT-nd
2876		( tar cf - . |
2877		    ( cd $NIGHTLY_PARENT_ROOT-nd; umask 0; tar xpf - ) ) 2>&1 |
2878		    tee -a $mail_msg_file >> $LOGFILE
2879	fi
2880fi
2881
2882#
2883# do shared library interface verification
2884#
2885
2886if [ "$A_FLAG" = "y" -a "$build_ok" = "y" ]; then
2887	echo "\n==== Check versioning and ABI information ====\n"  | \
2888	    tee -a $LOGFILE >> $mail_msg_file
2889
2890	rm -rf $SRC/interfaces.ref
2891	if [ -d $SRC/interfaces.out ]; then
2892		mv $SRC/interfaces.out $SRC/interfaces.ref
2893	fi
2894	rm -rf $SRC/interfaces.out
2895	mkdir -p $SRC/interfaces.out
2896
2897	intf_check -V -m -o -b $SRC/tools/abi/etc \
2898		-d $SRC/interfaces.out $checkroot 2>&1 | sort \
2899		> $SRC/interfaces.out/log
2900
2901	# report any ERROR found in log file
2902	fgrep 'ERROR' $SRC/interfaces.out/log | sed 's/^ERROR: //' | \
2903		tee -a $LOGFILE >> $mail_msg_file
2904
2905	if [ ! -d $SRC/interfaces.ref ] ; then
2906		mkdir -p $SRC/interfaces.ref
2907		if [ -d  $SRC/interfaces.out ]; then
2908			cp -r $SRC/interfaces.out/* $SRC/interfaces.ref
2909		fi
2910	fi
2911
2912	echo "\n==== Diff versioning warnings (since last build) ====\n" | \
2913	    tee -a $LOGFILE >> $mail_msg_file
2914
2915	out_vers=`grep ^VERSION $SRC/interfaces.out/log`;
2916	ref_vers=`grep ^VERSION $SRC/interfaces.ref/log`;
2917
2918	# Report any differences in WARNING messages between last
2919	# and current build.
2920	if [ "$out_vers" = "$ref_vers" ]; then
2921		diff $SRC/interfaces.ref/log $SRC/interfaces.out/log | \
2922		    fgrep 'WARNING' | sed 's/WARNING: //' | \
2923		    tee -a $LOGFILE >> $mail_msg_file
2924	fi
2925fi
2926
2927if [ "$r_FLAG" = "y" -a "$build_ok" = "y" ]; then
2928	echo "\n==== Check ELF runtime attributes ====\n" | \
2929	    tee -a $LOGFILE >> $mail_msg_file
2930
2931	LDDUSAGE="^ldd: does not support -e"
2932	LDDWRONG="wrong class"
2933	CRLERROR="^crle:"
2934	CRLECONF="^crle: configuration file:"
2935
2936	RUNTIMEREF=$SRC/runtime-${MACH}.ref
2937	RUNTIMEOUT=$SRC/runtime-${MACH}.out
2938
2939	rm -f $RUNTIMEREF
2940	if [ -f $RUNTIMEOUT ]; then
2941		egrep -v "$LDDUSAGE|$LDDWRONG|$CRLERROR|$CRLECONF" \
2942			$RUNTIMEOUT > $RUNTIMEREF
2943	fi
2944
2945	# If we're doing a debug build the proto area will be left with
2946	# debuggable objects, thus don't assert -s.
2947	if [ "$D_FLAG" = "y" ]; then
2948		rtime_sflag=""
2949	else
2950		rtime_sflag="-s"
2951	fi
2952	check_rtime -d $checkroot -i -m -o $rtime_sflag $checkroot 2>&1 | \
2953	    egrep -v ": unreferenced object=$checkroot/.*/lib(w|intl|thread|pthread).so" | \
2954	    egrep -v ": unused object=$checkroot/.*/lib(w|intl|thread|pthread).so" | \
2955	    sort > $RUNTIMEOUT
2956
2957	# Determine any processing errors that will affect the final output
2958	# and display these first.
2959	grep -l "$LDDUSAGE" $RUNTIMEOUT > /dev/null
2960	if (( $? == 0 )) ; then
2961	    echo "WARNING: ldd(1) does not support -e.  The version of ldd(1)" | \
2962		tee -a $LOGFILE >> $mail_msg_file
2963	    echo "on your system is old - 4390308 (s81_30) is required.\n" | \
2964		tee -a $LOGFILE >> $mail_msg_file
2965	fi
2966	grep -l "$LDDWRONG" $RUNTIMEOUT > /dev/null
2967	if (( $? == 0 )) ; then
2968	    echo "WARNING: wrong class message detected.  ldd(1) was unable" | \
2969		tee -a $LOGFILE >> $mail_msg_file
2970	    echo "to execute an object, thus it could not be checked fully." | \
2971		tee -a $LOGFILE >> $mail_msg_file
2972	    echo "Perhaps a 64-bit object was encountered on a 32-bit system," | \
2973		tee -a $LOGFILE >> $mail_msg_file
2974	    echo "or an i386 object was encountered on a sparc system?\n" | \
2975		tee -a $LOGFILE >> $mail_msg_file
2976	fi
2977	grep -l "$CRLECONF" $RUNTIMEOUT > /dev/null
2978	if (( $? == 0 )) ; then
2979	    echo "WARNING: creation of an alternative dependency cache failed." | \
2980		tee -a $LOGFILE >> $mail_msg_file
2981	    echo "Dependencies will bind to the base system libraries.\n" | \
2982		tee -a $LOGFILE >> $mail_msg_file
2983	    grep "$CRLECONF" $RUNTIMEOUT | \
2984		tee -a $LOGFILE >> $mail_msg_file
2985	    grep "$CRLERROR" $RUNTIMEOUT | grep -v "$CRLECONF" | \
2986		tee -a $LOGFILE >> $mail_msg_file
2987	    echo "\n" | tee -a $LOGFILE >> $mail_msg_file
2988	fi
2989
2990	egrep '<dependency no longer necessary>' $RUNTIMEOUT | \
2991	    tee -a $LOGFILE >> $mail_msg_file
2992
2993	# NEEDED= and RPATH= are informational; report anything else that we
2994	# haven't already.
2995	egrep -v "NEEDED=|RPATH=|$LDDUSAGE|$LDDWRONG|$CRLERROR|$CRLECONF" \
2996	    $RUNTIMEOUT | tee -a $LOGFILE >> $mail_msg_file
2997
2998	# probably should compare against a 'known ok runpaths' list
2999	if [ ! -f $RUNTIMEREF ]; then
3000		egrep -v "$LDDUSAGE|$LDDWRONG|$CRLERROR|$CRLECONF" \
3001			$RUNTIMEOUT >  $RUNTIMEREF
3002	fi
3003
3004	echo "\n==== Diff ELF runtime attributes (since last build) ====\n" \
3005	    >> $mail_msg_file
3006
3007	egrep -v "$LDDUSAGE|$LDDWRONG|$CRLERROR|$CRLECONF" $RUNTIMEOUT | \
3008	    diff $RUNTIMEREF - >> $mail_msg_file
3009fi
3010
3011# DEBUG lint of kernel begins
3012
3013if [ "$i_CMD_LINE_FLAG" = "n" -a "$l_FLAG" = "y" ]; then
3014	if [ "$LINTDIRS" = "" ]; then
3015		# LINTDIRS="$SRC/uts y $SRC/stand y $SRC/psm y"
3016		LINTDIRS="$SRC y"
3017	fi
3018	set $LINTDIRS
3019	while [ $# -gt 0 ]; do
3020		dolint $1 $2; shift; shift
3021	done
3022else
3023	echo "\n==== No '$MAKE lint' ====\n" >> $LOGFILE
3024fi
3025
3026# "make check" begins
3027
3028if [ "$i_CMD_LINE_FLAG" = "n" -a "$C_FLAG" = "y" ]; then
3029	# remove old check.out
3030	rm -f $SRC/check.out
3031
3032	rm -f $SRC/check-${MACH}.out
3033	cd $SRC
3034	$MAKE -ek check 2>&1 | tee -a $SRC/check-${MACH}.out >> $LOGFILE
3035	echo "\n==== cstyle/hdrchk errors ====\n" >> $mail_msg_file
3036
3037	grep ":" $SRC/check-${MACH}.out |
3038		egrep -v "Ignoring unknown host" | \
3039		sort | uniq >> $mail_msg_file
3040else
3041	echo "\n==== No '$MAKE check' ====\n" >> $LOGFILE
3042fi
3043
3044echo "\n==== Find core files ====\n" | \
3045    tee -a $LOGFILE >> $mail_msg_file
3046
3047find $abssrcdirs -name core -a -type f -exec file {} \; | \
3048	tee -a $LOGFILE >> $mail_msg_file
3049
3050if [ "$f_FLAG" = "y" -a "$build_ok" = "y" ]; then
3051	echo "\n==== Diff unreferenced files (since last build) ====\n" \
3052	    | tee -a $LOGFILE >>$mail_msg_file
3053	rm -f $SRC/unref-${MACH}.ref
3054	if [ -f $SRC/unref-${MACH}.out ]; then
3055		mv $SRC/unref-${MACH}.out $SRC/unref-${MACH}.ref
3056	fi
3057
3058	#
3059	# For any SCM other than teamware, we want to disable the
3060	# managed-by-SCCS test in findunref
3061	#
3062	findunref_all=""
3063	if [ "$SCM_TYPE" != teamware ]; then
3064		findunref_all="-a"
3065	fi
3066
3067	findunref $findunref_all -t $SRC/.build.tstamp $SRC/.. \
3068	    ${TOOLS}/findunref/exception_list 2>> $mail_msg_file | \
3069	    sort | sed -e s=^./src/=./= -e s=^./closed/=../closed/= \
3070	    > $SRC/unref-${MACH}.out
3071
3072	if [ ! -f $SRC/unref-${MACH}.ref ]; then
3073		cp $SRC/unref-${MACH}.out $SRC/unref-${MACH}.ref
3074	fi
3075
3076	diff $SRC/unref-${MACH}.ref $SRC/unref-${MACH}.out >>$mail_msg_file
3077fi
3078
3079#
3080# Generate the OpenSolaris deliverables if requested.  Some of these
3081# steps need to come after findunref and are commented below.
3082#
3083if [ "$O_FLAG" = y -a "$build_ok" = y ]; then
3084	echo "\n==== Generating OpenSolaris tarballs ====\n" | \
3085	    tee -a $mail_msg_file >> $LOGFILE
3086
3087	cd $CODEMGR_WS
3088
3089	#
3090	# This step grovels through the pkgdefs proto* files, so it
3091	# must come after findunref.
3092	#
3093	echo "Generating closed binaries tarball(s)..." >> $LOGFILE
3094	closed_basename=on-closed-bins
3095	if [ "$D_FLAG" = y ]; then
3096		bindrop "$ROOT" "$ROOT-open" "$closed_basename" \
3097		    >>"$LOGFILE" 2>&1
3098		if (( $? != 0 )) ; then
3099			echo "Couldn't create DEBUG closed binaries." |
3100			    tee -a $mail_msg_file >> $LOGFILE
3101		fi
3102	fi
3103	if [ "$F_FLAG" = n ]; then
3104		bindrop -n "$ROOT-nd" "$ROOT-open-nd" "$closed_basename-nd" \
3105		    >>"$LOGFILE" 2>&1
3106		if (( $? != 0 )) ; then
3107			echo "Couldn't create non-DEBUG closed binaries." |
3108			    tee -a $mail_msg_file >> $LOGFILE
3109		fi
3110	fi
3111
3112	echo "Generating SUNWonbld tarball..." >> $LOGFILE
3113	PKGARCHIVE=$PKGARCHIVE_ORIG
3114	onblddrop >> $LOGFILE 2>&1
3115	if (( $? != 0 )) ; then
3116		echo "Couldn't create SUNWonbld tarball." |
3117		    tee -a $mail_msg_file >> $LOGFILE
3118	fi
3119
3120	echo "Generating README.opensolaris..." >> $LOGFILE
3121	cat $SRC/tools/opensolaris/README.opensolaris.tmpl | \
3122	    mkreadme_osol $CODEMGR_WS/README.opensolaris >> $LOGFILE 2>&1
3123	if (( $? != 0 )) ; then
3124		echo "Couldn't create README.opensolaris." |
3125		    tee -a $mail_msg_file >> $LOGFILE
3126	fi
3127
3128	# This step walks the source tree, so it must come after
3129	# findunref.  It depends on README.opensolaris.
3130	echo "Generating source tarball..." >> $LOGFILE
3131	sdrop >>$LOGFILE 2>&1
3132	if (( $? != 0 )) ; then
3133		echo "Couldn't create source tarball." |
3134		    tee -a "$mail_msg_file" >> "$LOGFILE"
3135	fi
3136
3137	# This step depends on the closed binaries tarballs.
3138	echo "Generating BFU tarball(s)..." >> $LOGFILE
3139	if [ "$D_FLAG" = y ]; then
3140		makebfu_filt bfudrop "$ROOT-open" \
3141		    "$closed_basename.$MACH.tar.bz2" nightly-osol
3142		if (( $? != 0 )) ; then
3143			echo "Couldn't create DEBUG archives tarball." |
3144			    tee -a $mail_msg_file >> $LOGFILE
3145		fi
3146	fi
3147	if [ "$F_FLAG" = n ]; then
3148		makebfu_filt bfudrop -n "$ROOT-open-nd" \
3149		    "$closed_basename-nd.$MACH.tar.bz2" nightly-osol-nd
3150		if (( $? != 0 )) ; then
3151			echo "Couldn't create non-DEBUG archives tarball." |
3152			    tee -a $mail_msg_file >> $LOGFILE
3153		fi
3154	fi
3155fi
3156
3157# Verify that the usual lists of files, such as exception lists,
3158# contain only valid references to files.  If the build has failed,
3159# then don't check the proto area.
3160CHECK_PATHS=${CHECK_PATHS:-y}
3161if [ "$CHECK_PATHS" = y -a "$N_FLAG" != y ]; then
3162	echo "\n==== Check lists of files ====\n" | tee -a $LOGFILE \
3163		>>$mail_msg_file
3164	arg=-b
3165	[ "$build_ok" = y ] && arg=
3166	checkpaths $arg $checkroot 2>&1 | tee -a $LOGFILE >>$mail_msg_file
3167fi
3168
3169if [ "$M_FLAG" != "y" -a "$build_ok" = y ]; then
3170	echo "\n==== Impact on file permissions ====\n" \
3171		>> $mail_msg_file
3172	#
3173	# Get pkginfo files from usr/src/pkgdefs
3174	#
3175	pmodes -qvdP \
3176	`for d in $abssrcdirs; do
3177		if [ -d "$d/pkgdefs" ]
3178		then
3179			find $d/pkgdefs -name pkginfo.tmpl -print -o -name .del\* -prune
3180		fi
3181	 done | sed -e 's:/pkginfo.tmpl$::' | sort -u ` >> $mail_msg_file
3182fi
3183
3184if [ "$w_FLAG" = "y" -a "$build_ok" = "y" ]; then
3185	if [[ "$MULTI_PROTO" = no || "$D_FLAG" = y ]]; then
3186		do_wsdiff DEBUG $ROOT.prev $ROOT
3187	fi
3188
3189	if [[ "$MULTI_PROTO" = yes && "$F_FLAG" = n ]]; then
3190		do_wsdiff non-DEBUG $ROOT-nd.prev $ROOT-nd
3191	fi
3192fi
3193
3194END_DATE=`date`
3195echo "==== Nightly $maketype build completed: $END_DATE ====" | \
3196    tee -a $LOGFILE >> $build_time_file
3197
3198typeset -Z2 minutes
3199typeset -Z2 seconds
3200
3201elapsed_time=$SECONDS
3202((hours = elapsed_time / 3600 ))
3203((minutes = elapsed_time / 60  % 60))
3204((seconds = elapsed_time % 60))
3205
3206echo "\n==== Total build time ====" | \
3207    tee -a $LOGFILE >> $build_time_file
3208echo "\nreal    ${hours}:${minutes}:${seconds}" | \
3209    tee -a $LOGFILE >> $build_time_file
3210
3211if [ "$u_FLAG" = "y" -a "$f_FLAG" = "y" -a "$build_ok" = "y" ]; then
3212	staffer cp ${SRC}/unref-${MACH}.out $PARENT_WS/usr/src/
3213
3214	#
3215	# Produce a master list of unreferenced files -- ideally, we'd
3216	# generate the master just once after all of the nightlies
3217	# have finished, but there's no simple way to know when that
3218	# will be.  Instead, we assume that we're the last nightly to
3219	# finish and merge all of the unref-${MACH}.out files in
3220	# $PARENT_WS/usr/src/.  If we are in fact the final ${MACH} to
3221	# finish, then this file will be the authoritative master
3222	# list.  Otherwise, another ${MACH}'s nightly will eventually
3223	# overwrite ours with its own master, but in the meantime our
3224	# temporary "master" will be no worse than any older master
3225	# which was already on the parent.
3226	#
3227
3228	set -- $PARENT_WS/usr/src/unref-*.out
3229	cp "$1" ${TMPDIR}/unref.merge
3230	shift
3231
3232	for unreffile; do
3233		comm -12 ${TMPDIR}/unref.merge "$unreffile" > ${TMPDIR}/unref.$$
3234		mv ${TMPDIR}/unref.$$ ${TMPDIR}/unref.merge
3235	done
3236
3237	staffer cp ${TMPDIR}/unref.merge $PARENT_WS/usr/src/unrefmaster.out
3238fi
3239
3240#
3241# All done save for the sweeping up.
3242# (whichever exit we hit here will trigger the "cleanup" trap which
3243# optionally sends mail on completion).
3244#
3245if [ "$build_ok" = "y" ]; then
3246	exit 0
3247fi
3248exit 1
3249